/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with
 this software; see the file COPYING. If not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other
 files to produce an executable, this does not by itself cause the resulting
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the
 HMG library code into it.

 Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include 'hmg.ch'
#include 'common.ch'

memVar aTemp
memvar retarray
*-----------------------------------------------------------------------------*
Function _DefineGrid (  ControlName , ;
         ParentForm  , ;
         x     , ;
         y     , ;
         w     , ;
         h     , ;
         aHeaders , ;
         aWidths     , ;
         aRows    , ;
         value    , ;
         fontname , ;
         fontsize , ;
         tooltip     , ;
         change      , ;
         dblclick , ;
         aHeadClick  , ;
         gotfocus , ;
         lostfocus   , ;
         nogrid      , ;
         aImage      , ;
         aJust    , ;
         break    , ;
         HelpId      , ;
         bold     , ;
         italic      , ;
         underline   , ;
         strikeout   , ;
         ownerdata   , ;
         ondispinfo  , ;
         itemcount   , ;
         available0  , ;
         available1  , ;
         available2  , ;
         multiselect , ;
         available3  , ;
         backcolor   , ;
         fontcolor   , ;
         inplace     , ;
         editcontrols   , ;
         dynamicbackcolor ,;
         dynamicforecolor ,;
         columnvalid ,    ;
         columnwhen ,     ;
         columnheaders ,   ;
         aHeaderImages ,   ;
         cellnavigation ,  ;
         recordsource   , ;
         columnfields   , ;
         append      , ;
         buffered , ;
         allowdelete     , ;
         dynamicdisplay    , ;
         onsave      , ;
         lockcolumns ;
         )
*-----------------------------------------------------------------------------*
Local i , cParentForm , mVar, wBitmap , k := 0
Local ControlHandle
Local FontHandle
Local cParentTabName
Local nHeaderImageListHandle := Nil
Local aTemp
Local ldfc
Local ldbc
Local aColumnClassMap   := {}
Local aFieldNames := {}
Local j


Available1 := Nil
Available2 := Nil
Available3 := Nil

   DEFAULT INPLACE TO .F.
   DEFAULT columnheaders TO .T.

   if valtype ( lockcolumns ) == 'U'

      lockcolumns := 0

   endif

   if valtype ( recordsource ) == 'C'

      If Select( RecordSource ) == 0

         MsgHMGError ("Grid: 'RecordSource' WorkArea must be open at control definition. Program Terminated")

      EndIf

      ownerdata   := .t.
      itemcount   := &recordsource->(GetDataGridRecCount())
      cellnavigation := .t.
      buffered := .t.
      aRows    := Nil

      aSize ( aColumnClassMap , Len ( aHeaders ) )

      aSize ( aFieldNames , &recordsource->( FCOUNT() ) )
           &recordsource->( AFIELDS(aFieldNames))

      aFill ( aColumnClassMap , 'E' )

           For i := 1 To Len ( ColumnFields )

              For j := 1 To Len ( aFieldNames )

            If alltrim( Upper( ColumnFields [i] ) ) == alltrim( Upper( aFieldNames [j] ) )

               aColumnClassMap [ i ] := 'F'
               Exit

            EndIf

         Next j

      Next i


      if inplace
         if valtype(editcontrols) <> 'A'
            MsgHMGError ("Grid: 'ColumnControls' must be specified when 'RecordSource' was set. Program Terminated")
         endif
      endif

      aTemp := array ( len(aHeaders) )
      afill ( aTemp , { || { 0 , 0 , 0 } } )

      if valtype ( dynamicforecolor ) = 'U'

         if valtype ( fontcolor ) = 'U'

            ldfc  := .F.
            dynamicforecolor := aTemp

         else

            ldfc  := .T.
            dynamicforecolor := array ( len(aHeaders) )
            afill ( dynamicforecolor , { || fontcolor } )

         endif


      else
         ldfc  := .T.
      endif

      if valtype ( dynamicbackcolor ) = 'U'

         if valtype ( backcolor ) == 'A'

            dynamicbackcolor = array ( len(aHeaders) )
            afill ( dynamicbackcolor , { || backcolor } )

         endif

      endif

   endif

   If valtype(columnfields) == 'A'
      If valtype ( recordsource ) != 'C'
         MsgHMGError ("Grid: 'ColumnFields' can be specified only for a 'RowSource' bound Grid. Program Terminated")
      Endif
   Endif

   If append == .T.
      If valtype ( recordsource ) != 'C'
         MsgHMGError ("Grid: 'AllowAppend' can be specified only for a 'RowSource' bound Grid. Program Terminated")
      Endif
   Endif

   If allowdelete == .T.
      If valtype ( recordsource ) != 'C'
         MsgHMGError ("Grid: 'AllowDelete' can be specified only for a 'RowSource' bound Grid. Program Terminated")
      Endif
   Endif

   If buffered == .T.
      If valtype ( recordsource ) != 'C'
         MsgHMGError ("Grid: 'Buffered' can be specified only for a 'RowSource' bound Grid. Program Terminated")
      Endif
   Endif

   If valtype(dynamicdisplay) == 'A'
      If valtype ( recordsource ) != 'C'
         MsgHMGError ("Grid: 'DynamicDisplay' can be specified only for a 'RowSource' bound Grid. Program Terminated")
      Endif
   Endif

   if _HMG_SYSDATA [ 264 ] = .T.
      ParentForm := _HMG_SYSDATA [ 223 ]
      if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
         FontName := _HMG_SYSDATA [ 224 ]
      EndIf
      if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
         FontSize := _HMG_SYSDATA [ 182 ]
      EndIf
   endif

   if _HMG_SYSDATA [ 183 ] > 0
      IF _HMG_SYSDATA [ 240 ] == .F.
      x  := x + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
      y  := y + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]]
      ParentForm := _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
      cParentTabName := _HMG_SYSDATA [ 225 ]
      ENDIF
   EndIf

   If .Not. _IsWindowDefined (ParentForm)
      MsgHMGError(_HMG_SYSDATA [ 136 ][1]+ ParentForm + _HMG_SYSDATA [ 136 ][2])
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgHMGError (_HMG_SYSDATA [ 136 ][4] + ControlName + _HMG_SYSDATA [ 136 ][5] + ParentForm + _HMG_SYSDATA [ 136 ][6])
   endif

   if ValType ( aWidths ) == 'U'
      MsgHMGError ("Grid: WIDTHS not defined .Program Terminated")
   EndIf

   if columnheaders == .F.
      aHeaders := array ( Len ( aWidths ) )
      afill ( aHeaders , '' )
   endif

   if ValType ( aHeaders ) == 'U'
      MsgHMGError ("Grid: HEADERS not defined .Program Terminated")
   EndIf

   if Len ( aHeaders ) != Len ( aWidths )
      MsgHMGError ("Browse/Grid: FIELDS/HEADERS/WIDTHS array size mismatch .Program Terminated")
   EndIf
   if ValType (aRows) != 'U'
      if Len (aRows) > 0
         if Len (aRows[1]) != Len ( aHeaders )
            MsgHMGError ("Grid: ITEMS length mismatch. Program Terminated")
         EndIf
      EndIf
   EndIf

   mVar := '_' + ParentForm + '_' + ControlName

   cParentForm = ParentForm

   ParentForm = GetFormHandle (ParentForm)

   if valtype(w) == "U"
      w := 240
   endif
   if valtype(h) == "U"
      h := 120
   endif
   if valtype(value) == "U" .and. !MultiSelect
      value := 0
   endif
   if valtype(aRows) == "U"
      aRows := {}
   endif
   if valtype(aJust) == "U"      // Grid+
      aJust := Array( len( aHeaders ) )
      aFill( aJust, 0 )
   else
      aSize( aJust, len( aHeaders ) )
      aEval( aJust, { |x| x := iif( x == NIL, 0, x ) } )
   endif
   if valtype(aImage) == "U"        // Grid+
      aImage := {}
   endif

   if valtype(x) == "U" .or. valtype(y) == "U"

      If _HMG_SYSDATA [ 216 ] == 'TOOLBAR'
         Break := .T.
      EndIf

      _HMG_SYSDATA [ 216 ] := 'GRID'

      i := GetFormIndex ( cParentForm )

      if i > 0

         ControlHandle := InitListView ( _HMG_SYSDATA [ 87 ] [i] , 0, 0, 0, w, h ,'',0,iif( nogrid, 0, 1 ) , ownerdata , itemcount , multiselect , columnheaders )

         if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
            FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
         Else
            FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
         endif

         AddSplitBoxItem ( Controlhandle, _HMG_SYSDATA [ 87 ] [i] , w , break , , , , _HMG_SYSDATA [ 258 ] )
      EndIf

   Else

      ControlHandle := InitListView ( ParentForm, 0, x, y, w, h ,'',0, iif( nogrid, 0, 1 ) , ownerdata  , itemcount  , multiselect , columnheaders )

      if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
         FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
      Else
         FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
      endif

   endif

   If ValType (backcolor) != 'U'
      ListView_SetBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3] )
      ListView_SetTextBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3]  )
   EndIf

   If ValType (fontcolor) != 'U'
      ListView_SetTextColor ( ControlHandle , fontcolor[1] , fontcolor[2] , fontcolor[3]  )
   EndIf

   wBitmap := iif( len( aImage ) > 0, AddListViewBitmap( ControlHandle, aImage ), 0 )
   aWidths[1] := max ( aWidths[1], wBitmap + 2 ) // Set Column 1 width to Bitmap width

   If _HMG_SYSDATA [ 265 ] = .T.
      aAdd ( _HMG_SYSDATA [ 142 ] , ControlHandle )
   EndIf

   if valtype(aHeadClick) == "U"
      aHeadClick := {}
   endif

   if valtype(change) == "U"
      change := ""
   endif

   if valtype(dblclick) == "U"
      dblclick := ""
   endif

   if valtype(tooltip) != "U"
           SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
   endif



   k := _GetControlFree()

   Public &mVar. := k

   _HMG_SYSDATA [1] [k] := if ( multiselect , "MULTIGRID" , "GRID" )
   _HMG_SYSDATA [2] [k] :=   ControlName
   _HMG_SYSDATA [3] [k] :=   ControlHandle
   _HMG_SYSDATA [4] [k] :=   ParentForm
   _HMG_SYSDATA [  5 ] [k] :=   0
   _HMG_SYSDATA [  6 ] [k] :=   ondispinfo
   _HMG_SYSDATA [  7 ] [k] :=  aHeaders
   _HMG_SYSDATA [  8 ] [k] :=  Value
   _HMG_SYSDATA [  9 ] [k] :=  Nil
   _HMG_SYSDATA [ 10 ] [k] :=  lostfocus
   _HMG_SYSDATA [ 11 ] [k] :=  gotfocus
   _HMG_SYSDATA [ 12 ] [k] :=  change
   _HMG_SYSDATA [ 13 ] [k] :=  .F.
   _HMG_SYSDATA [ 14 ] [k] :=  aImage
   _HMG_SYSDATA [ 15 ] [k] := 1
   _HMG_SYSDATA [ 16 ] [k] :=  dblclick
   _HMG_SYSDATA [ 17 ] [k] :=  aHeadClick
   _HMG_SYSDATA [ 18 ] [k] := y
   _HMG_SYSDATA [ 19 ] [k] := x
   _HMG_SYSDATA [ 20 ] [k] :=  w
   _HMG_SYSDATA [ 21 ] [k] :=  h
   _HMG_SYSDATA [ 22 ] [k] := Nil
   _HMG_SYSDATA [ 23 ] [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 )
   _HMG_SYSDATA [ 24 ] [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 )
   _HMG_SYSDATA [ 25 ] [k] :=  Nil
   _HMG_SYSDATA [ 26 ] [k] :=  0
   _HMG_SYSDATA [ 27 ] [k] :=  fontname
   _HMG_SYSDATA [ 28 ] [k] :=  fontsize
   _HMG_SYSDATA [ 29 ] [k] :=  {bold,italic,underline,strikeout}
   _HMG_SYSDATA [ 30 ] [k] :=  tooltip
   _HMG_SYSDATA [ 31 ] [k] :=  cParentTabName
   _HMG_SYSDATA [ 32 ] [k] :=  cellnavigation
   _HMG_SYSDATA [ 33 ] [k] :=   aHeaders
   _HMG_SYSDATA [ 34 ] [k] :=  .t.
   _HMG_SYSDATA [ 35 ] [k] :=   HelpId
   _HMG_SYSDATA [ 36 ] [k] :=  FontHandle
   _HMG_SYSDATA [ 37 ] [k] :=  aJust
   _HMG_SYSDATA [ 38 ] [k] :=   .T.
   _HMG_SYSDATA [ 39 ] [k] := 0
   _HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

   _HMG_SYSDATA [ 40 ] [ K ] [  1 ] := inplace
   _HMG_SYSDATA [ 40 ] [ K ] [  2 ] := editcontrols
   _HMG_SYSDATA [ 40 ] [ K ] [  3 ] := dynamicbackcolor
   _HMG_SYSDATA [ 40 ] [ K ] [  4 ] := dynamicforecolor
   _HMG_SYSDATA [ 40 ] [ K ] [  5 ] := columnvalid
   _HMG_SYSDATA [ 40 ] [ K ] [  6 ] := columnwhen
   _HMG_SYSDATA [ 40 ] [ K ] [  9 ] := OWNERDATA
   _HMG_SYSDATA [ 40 ] [ K ] [ 10 ] := recordsource
   _HMG_SYSDATA [ 40 ] [ K ] [ 11 ] := columnfields
   _HMG_SYSDATA [ 40 ] [ K ] [ 12 ] := append
   _HMG_SYSDATA [ 40 ] [ K ] [ 13 ] := if ( valtype (columnfields) == 'A' , array ( len (columnfields) ) , Nil )
   _HMG_SYSDATA [ 40 ] [ K ] [ 14 ] := .F.
   _HMG_SYSDATA [ 40 ] [ K ] [ 15 ] := buffered
   _HMG_SYSDATA [ 40 ] [ K ] [ 16 ] := ldfc
   _HMG_SYSDATA [ 40 ] [ K ] [ 17 ] := allowdelete
   _HMG_SYSDATA [ 40 ] [ K ] [ 18 ] := dynamicdisplay
   _HMG_SYSDATA [ 40 ] [ K ] [ 19 ] := .F.
   _HMG_SYSDATA [ 40 ] [ K ] [ 20 ] := .F. // Pending Edit Updates Flag
   _HMG_SYSDATA [ 40 ] [ K ] [ 21 ] := {}  // Edit Updates Buffer
   _HMG_SYSDATA [ 40 ] [ K ] [ 22 ] := 0   // Appended Record Buffer Count ( Negative )
   _HMG_SYSDATA [ 40 ] [ K ] [ 23 ] := ItemCount // Buffered Session Initial ItemCount
   _HMG_SYSDATA [ 40 ] [ K ] [ 24 ] :=  0 // Deleted / Recalled record count
   _HMG_SYSDATA [ 40 ] [ K ] [ 25 ] := {} // Delete / Recall Buffer Array { nLogicalRow , nPhysicalRow , cStatus ( 'D' or 'R' ) }
   _HMG_SYSDATA [ 40 ] [ K ] [ 26 ] := OnSave
   _HMG_SYSDATA [ 40 ] [ K ] [ 27 ] := 255
   _HMG_SYSDATA [ 40 ] [ K ] [ 28 ] := backcolor
   _HMG_SYSDATA [ 40 ] [ K ] [ 29 ] := fontcolor
   _HMG_SYSDATA [ 40 ] [ K ] [ 30 ] := aColumnClassMap
   _HMG_SYSDATA [ 40 ] [ K ] [ 31 ] := aWidths
   _HMG_SYSDATA [ 40 ] [ K ] [ 32 ] := lockcolumns
   _HMG_SYSDATA [ 40 ] [ K ] [ 33 ] := .T.
   _HMG_SYSDATA [ 40 ] [ K ] [ 34 ] := .T.

   InitListViewColumns ( ControlHandle, aHeaders , aWidths, aJust )

   for i := 1 to len (arows)
         _AddGridRow ( ControlName, cParentForm, arows [i] )
   next i

   if multiselect == .T.

      if VALTYPE ( value ) == 'A'
         ListViewSetMultiSel (ControlHandle,value)
      endif

   Else

      If CellNavigation == .T.
         _SetValue ( , , Value , k )
      Else

         if Value <> 0
            ListView_SetCursel (ControlHandle , Value )
         endif

      EndIf

   EndIf

   If ValType(aHeaderImages) <> "U"
      nHeaderImageListHandle := SetListViewHeaderImages ( ControlHandle , aHeaderImages , aJust )
      _HMG_SYSDATA [ 22 ] [k] := aHeaderImages
      _HMG_SYSDATA [ 26 ] [k] := nHeaderImageListHandle
   EndIf

   _HMG_DOGRIDREFRESH(K)

Return Nil

*-----------------------------------------------------------------------------*
Function _AddGridRow ( ControlName, ParentForm, aRow )
*-----------------------------------------------------------------------------*
Local h, i, iIm := 0 , x

LOCAL ATEMP := {}

   i := GetControlIndex ( ControlName , ParentForm )

   if Len ( _HMG_SYSDATA [  7 ] [i] )  != Len ( aRow )
      MsgHMGError ("Grid.AddItem: Item size mismatch. Program Terminated")
   EndIf

        h := GetControlHandle ( ControlName, ParentForm )

   IF VALTYPE ( _HMG_SYSDATA [40] [I] [2] ) == 'A'

      ATEMP := ARRAY ( LEN (AROW) )
      AFILL ( ATEMP , '' )

      if  len( _HMG_SYSDATA [ 14 ][i] ) > 0
         iIm   := aRow[1]
         aRow[1] := NIL
         aTemp[1] := NIL
      endif

      AddListViewItems ( h , aTemp , iIm )

      _SetItem ( ControlName , ParentForm , LISTVIEWGETITEMCOUNT(H) , aRow )

   ELSE

      if  len( _HMG_SYSDATA [ 14 ][i] ) > 0
         iIm   := aRow[1]
         aRow[1] := NIL
      endif

      AddListViewItems ( h , aRow, iIm )

      _HMG_DOGRIDREFRESH(I)

   ENDIF

Return Nil

*------------------------------------------------------------------------------*
Procedure _AddGridColumn ( cControlName , cParentForm , nColIndex , cCaption , nWidth , nJustify )
*------------------------------------------------------------------------------*
Local i , x  , atemp := {}

   // Get Control Index

   i := GetControlIndex ( cControlName , cParentForm )

   // Set Default Values

   If ValType ( nColIndex ) == 'U'
      nColIndex := Len ( _HMG_SYSDATA [  7 ] [i] ) + 1
   EndIf

   If ValType ( cCaption ) == 'U'
      cCaption := ''
   EndIf

   If ValType ( nWidth ) == 'U'
      nWidth := 120
   EndIf

   If ValType ( nJustify ) == 'U'
      nJustify := 0
   EndIf

   // Update Grid Object

   For x := 1 To nColIndex - 1
      aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
   Next x

   aadd ( atemp , cCaption )

   For x := nColIndex + 1 To Len ( _HMG_SYSDATA [  7 ] [i] ) + 1
      aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x-1] )
   Next x

   _HMG_SYSDATA [  7 ] [i] := atemp
   _HMG_SYSDATA [ 33 ] [i] := atemp

   // Call C-Level Routine

   ListView_AddColumn( _HMG_SYSDATA [3][i] , nColIndex , nWidth , cCaption , nJustify )

Return

*------------------------------------------------------------------------------*
Procedure _DeleteGridColumn ( cControlName , cParentForm , nColIndex )
*------------------------------------------------------------------------------*
Local i , x  , atemp := {}

   // Get Control Index

   i := GetControlIndex ( cControlName , cParentForm )

   // Update Grid Object

   For x := 1 To nColIndex - 1
      aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
   Next x

   For x := nColIndex + 1 To Len ( _HMG_SYSDATA [  7 ] [i] )
      aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
   Next x

   _HMG_SYSDATA [  7 ] [i] := atemp
   _HMG_SYSDATA [ 33 ] [i] := atemp

   // Call C-Level Routine

   ListView_DeleteColumn ( _HMG_SYSDATA [3][i] , nColIndex )

Return

*-----------------------------------------------------------------------------*
FUNCTION _HMG_GRIDINPLACEEDIT(IDX)
*-----------------------------------------------------------------------------*
Local r , c , h , i , aTemp , ri , ci , X , DW := 0, DH := 0 , DR := 0 , DC := 0
LOCAL AEDITCONTROLS
LOCAL AEC := 'TEXTBOX'
LOCAL AITEMS := {}
LOCAL ARANGE := {}
LOCAL DTYPE := 'D'
LOCAL ALABELS := { '.T.' ,'.F.' }
LOCAL CTYPE := 'CHARACTER'
LOCAL CINPUTMASK := ''
LOCAL CFORMAT := ''
LOCAL XRES := {}
LOCAL CVA
LOCAL CWH
LOCAL VALID
LOCAL WHEN
LOCAL GFN
LOCAL GFS
LOCAL V
Local nWx := 0
Local nHx := 0
LOCAL ARETURNVALUES
LOCAL Z
Local xValue := 0
Local cRecordSource
Local b

   If _HMG_SYSDATA [ 232 ] == 'GRID_WHEN'
      MsgHMGError("GRID: Editing within a grid 'when' event procedure is not allowed. Program terminated" )
   EndIf
   If _HMG_SYSDATA [ 232 ] == 'GRID_VALID'
      MsgHMGError("GRID: Editing within a grid 'valid' event procedure is not allowed. Program terminated" )
   EndIf


   IF _HMG_SYSDATA [32] [idx] == .F.

      If This.CellRowIndex != LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [ idx ] )
         Return .f.
      EndIf

   ELSE

      If This.CellRowIndex != _HMG_SYSDATA [39] [ idx ]
         Return .f.
      EndIf

   ENDIF

   ri := This.CellRowIndex
   ci := This.CellColIndex

   if ri == 0 .or. ci == 0
      return  .f.
   endif

   IF valtype ( _HMG_SYSDATA [ 40 ] [ idx ] [ 10 ] ) == 'C'

      if IsDataGridDeleted ( idx , ri )
         return .f.
      endif

      cRecordSource   := _HMG_SYSDATA [ 40 ] [ idx ] [ 10 ]

      if &cRecordSource->(RddName()) == 'PGRDD'
         MsgHMGError("GRID: Modify PostGre RDD tables is not allowed. Program terminated" )
      endif

      if &cRecordSource->(RddName()) == 'SQLMIX'
         MsgHMGError("GRID: Modify SQLMIX RDD tables is not allowed. Program terminated" )
      endif

   endif

   GFN := _HMG_SYSDATA [ 27 ] [idx]
   GFS := _HMG_SYSDATA [ 28 ] [idx]


//Problem3031

   IF _HMG_SYSDATA [ 40 ] [ idx ] [ 9 ] == .F.

      aTemp := this.item(ri)

      v := aTemp [ci]

   ELSE

      _HMG_SYSDATA [ 201 ] := ri   // QueryRowIndex

      _HMG_SYSDATA [ 202 ] := ci   // QueryColIndex

      _HMG_SYSDATA [ 320 ] := .T.

      IF valtype ( _HMG_SYSDATA [ 40 ] [ idx ] [ 10 ] ) == 'C'

         GetDataGridCellData ( idx , .t. )

      ELSE

         Eval( _HMG_SYSDATA [  6 ] [ idx ]  )

      ENDIF


      _HMG_SYSDATA [ 320 ] := .F.


      v := _HMG_SYSDATA [ 230 ]      // QueryData

   ENDIF

   CWH :=    _HMG_SYSDATA [40] [IDX] [6]

//Problem3031

   IF VALTYPE ( CWH ) = 'A'

      IF LEN ( CWH ) >= CI

         IF VALTYPE ( CWH [CI] ) = 'B'

            _HMG_SYSDATA [ 318 ] := V

            _HMG_SYSDATA [ 232 ] := 'GRID_WHEN'

            WHEN := EVAL ( CWH [CI] )

            _HMG_SYSDATA [ 232 ] := ''

            IF WHEN = .F.
               _HMG_SYSDATA [ 256 ] := .F.
               RETURN .f.
            ENDIF

         ENDIF

      ENDIF

   ENDIF

   h := _HMG_SYSDATA [3] [IDX]

   r := This.CellRow + GetWindowRow ( h ) - this.row - 1

   if _HMG_SYSDATA [ 23 ]  [idx] <> -1
      r := r - _HMG_SYSDATA [ 23 ] [idx]
   endif

   c := This.CellCol + GetWindowCol ( h ) - this.col + 2

   if _HMG_SYSDATA [ 24 ] [idx] <> -1
      c := c - _HMG_SYSDATA [ 24 ] [idx]
   endif

   AEDITCONTROLS := _HMG_SYSDATA [ 40 ] [ IDX ] [ 2 ]

   CVA :=    _HMG_SYSDATA [ 40 ] [ IDX ] [ 5 ]

   XRES := _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )

   AEC      := XRES [1]
   CTYPE      := XRES [2]
   CINPUTMASK   := XRES [3]
   CFORMAT      := XRES [4]
   AITEMS      := XRES [5]
   ARANGE      := XRES [6]
   DTYPE      := XRES [7]
   ALABELS      := XRES [8]
   ARETURNVALUES   := XRES [9]

   IF AEC = 'COMBOBOX'
      DH := 1
   ELSEIF AEC = 'CHECKBOX'
      DR := 3
      DH := -7
   ELSEIF AEC = 'EDITBOX'
      _HMG_SYSDATA [321] := .T.
   ENDIF

   _HMG_SYSDATA [ 109 ] := GetActiveWindow()


   * Grid Valid Event Procedure Values

   _HMG_SYSDATA [ 209 ] := idx

   *

   _HMG_SYSDATA [ 245 ] := .F.

   IF AEC = 'EDITBOX'

      // + IF ( IsVista() .and. IsAppThemed() , 9 , 0 )
      // + IF ( IsVista() .and. IsAppThemed() , 6 , 0 )

      DEFINE WINDOW _hmg_grid_inplaceedit AT 0 , 0 ;
         WIDTH   350    ;
         HEIGHT   350 + IF ( IsAppThemed() , 3 , 0 ) ;
         TITLE _HMG_SYSDATA [  7 ] [ idx ] [ ci ] ;
         MODAL ;
         NOSIZE ;
         SHORTTITLEBAR

   else

      DEFINE WINDOW _hmg_grid_inplaceedit AT r + DR , c + DC ;
         WIDTH This.CellWidth +  DW ;
         HEIGHT This.CellHeight + 6 + DH ;
         TITLE '' ;
         MODAL NOSIZE NOCAPTION

   endif

   ON KEY ESCAPE ACTION ( _HMG_SYSDATA [ 256 ] := .T. , THISWINDOW.RELEASE )



   IF AEC = 'EDITBOX'

      ON KEY CONTROL+W ACTION IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , ( _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues ) ) , NIL )

      define button ok
         row   298
         col   278 - IF ( IsAppThemed() , 1 , 0 )
         width   28
         height   28
         action   IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , ( _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues ) ) , NIL )
         picture   'GRID_MSAV'
         tooltip _hmg_sysdata [ 133 ] [ 12 ] + ' [Ctrl+W]'
      end button

      define button cancel
         row   298
         col   312 - IF ( IsAppThemed() , 1 , 0 )
         width   28
         height   28
         action   ( _HMG_SYSDATA [ 256 ] := .T. , THISWINDOW.RELEASE )
         picture   'GRID_MCAN'
         tooltip _hmg_sysdata [ 133 ] [ 13 ] + ' [Esc]'
      end button


   ELSE

      ON KEY RETURN ACTION IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , (                               _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues ) ) , NIL )
      ON KEY TAB    ACTION ( _HMG_SYSDATA [ 285 ] := .T. , InsertReturn() )

   ENDIF


   ON KEY F2 ACTION IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , ( _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues ) ) , NIL )


   IF AEC == 'TEXTBOX' //*****************************************

      IF _HMG_SYSDATA [321] == .F.

         DEFINE TEXTBOX T

      ELSE

         DEFINE EDITBOX T

                 HSCROLLBAR      .F.
            VSCROLLBAR      .F.

      ENDIF

      FONTNAME   GFN
      FONTSIZE   GFS

      ROW   0
      COL   0
      WIDTH    This.CellWidth      + nWx
      HEIGHT   This.CellHeight + 6   + nHx

      IF CTYPE == 'NUMERIC'
         NUMERIC .T.
      ELSEIF CTYPE == 'DATE'
         DATE .T.
      ENDIF

      VALUE   v

      IF ! EMPTY ( CINPUTMASK )
         INPUTMASK CINPUTMASK
      ENDIF

      IF ! EMPTY ( CFORMAT )
         FORMAT CFORMAT
      ENDIF

      IF _HMG_SYSDATA [321] == .F.
         END TEXTBOX
      ELSE
         END EDITBOX
      ENDIF


   ELSEIF AEC == 'EDITBOX' //**********************************************

      DEFINE EDITBOX T
         HSCROLLBAR   .T.
         VSCROLLBAR   .T.
         FONTNAME   GFN
         FONTSIZE   GFS
         ROW      2
         COL      2
         WIDTH      340
         HEIGHT      292
         VALUE      v
      END EDITBOX

   ELSEIF AEC == 'DATEPICKER' //*******************************************

      DEFINE DATEPICKER D
         FONTNAME   GFN
         FONTSIZE   GFS
         ROW      0
         COL      0
         WIDTH      This.CellWidth
         HEIGHT      This.CellHeight + 6
         VALUE      V
         SHOWNONE   .T.

         IF DTYPE = 'DROPDOWN'
            UPDOWN .F.
         ELSEIF DTYPE = 'UPDOWN'
            UPDOWN .T.
         ENDIF

      END DATEPICKER

   ELSEIF AEC == 'COMBOBOX' //********************************************

      DEFINE COMBOBOX C
         FONTNAME   GFN
         FONTSIZE   GFS
         ROW   0
         COL   0
         WIDTH    This.CellWidth
         ITEMS   AITEMS

         IF LEN ( ARETURNVALUES ) == 0
            VALUE   v
         ELSE

            For z := 1 To Len ( aReturnValues )

               if v = aReturnValues [z]

                  xValue := z
                  exit

               endif

            Next z

            if xValue == 0
               xValue := 1
            endif

            VALUE xValue

         ENDIF

         ONDROPDOWN   _hmg_grid_disablekeys()
         ONCLOSEUP   _hmg_grid_enablekeys( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues )

      END COMBOBOX

   ELSEIF AEC == 'SPINNER' //*********************************************

      DEFINE SPINNER S
         FONTNAME   GFN
         FONTSIZE   GFS
              ROW      0
         COL      0
         WIDTH       This.CellWidth
         HEIGHT      This.CellHeight + 6
         VALUE      V
         RANGEMIN   ARANGE [1]
         RANGEMAX   ARANGE [2]
      END SPINNER

   ELSEIF AEC == 'CHECKBOX' //********************************************

      DEFINE CHECKBOX C
         FONTNAME   GFN
         FONTSIZE   GFS
         ROW      0
         COL      0
         WIDTH       This.CellWidth + DW
         HEIGHT      This.CellHeight + 6 + DH
         VALUE      V

         IF V == .T.
            CAPTION ALABELS [1]
         ELSEIF V == .F.
            CAPTION ALABELS [2]
         ENDIF

         BACKCOLOR WHITE
         ONCHANGE IF ( THIS.VALUE == .T. , THIS.CAPTION := ALABELS [1] , THIS.CAPTION := ALABELS [2] )
      END CHECKBOX

   ENDIF

   END WINDOW


   IF AEC = 'EDITBOX'

      SETFOCUS ( GetControlHandle( 't' , '_hmg_grid_inplaceedit' ) )

      CENTER WINDOW _hmg_grid_inplaceedit

   ENDIF

   ACTIVATE WINDOW _hmg_grid_inplaceedit

   _HMG_SYSDATA [ 109 ] := 0

   SETFOCUS ( _HMG_SYSDATA [3] [IDX] )

   _HMG_SYSDATA [321] := .F.

RETURN .t.

procedure _hmg_grid_disablekeys

   RELEASE KEY RETURN OF _hmg_grid_inplaceedit
   RELEASE KEY ESCAPE OF _hmg_grid_inplaceedit

return

procedure _hmg_grid_enablekeys( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues )

   ON KEY RETURN OF _hmg_grid_inplaceedit ACTION IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , ( _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues ) ) , NIL )

   ON KEY ESCAPE OF _hmg_grid_inplaceedit ACTION ( _HMG_SYSDATA [ 256 ] := .T. , _hmg_grid_inplaceedit.RELEASE )

return


*-----------------------------------------------------------------------------*
FUNCTION _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )
*-----------------------------------------------------------------------------*
LOCAL AEC := 'TEXTBOX'
LOCAL AITEMS := {}
LOCAL ARANGE := {}
LOCAL DTYPE := 'D'
LOCAL ALABELS := { '.T.' ,'.F.' }
LOCAL CTYPE := 'CHARACTER'
LOCAL CINPUTMASK := ''
LOCAL CFORMAT := ''
LOCAL ARET := {}
LOCAL DW , DH , DR , DC
LOCAL ARETURNVALUES := {}

   IF VALTYPE ( AEDITCONTROLS ) = 'A'

      IF LEN ( AEDITCONTROLS ) >= ci

         IF VALTYPE ( AEDITCONTROLS [CI] ) = 'A'

            IF LEN ( AEDITCONTROLS [CI] ) >= 1

               AEC := AEDITCONTROLS [CI] [1]

               IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
                  .AND. ;
                  AEC == 'TEXTBOX'

                  IF VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C'
                     CTYPE := AEDITCONTROLS [CI] [2]
                  ENDIF

                  IF LEN ( AEDITCONTROLS [CI] ) >= 3
                     IF VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'C'
                        CINPUTMASK := AEDITCONTROLS [CI] [3]
                     ENDIF
                  ENDIF

                  IF LEN ( AEDITCONTROLS [CI] ) >= 4
                     IF VALTYPE ( AEDITCONTROLS [CI] [4] ) = 'C'
                        CFORMAT := AEDITCONTROLS [CI] [4]
                     ENDIF
                  ENDIF

               ENDIF

               IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
                  .AND. ;
                  AEC == 'COMBOBOX'

                  IF VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'A'
                     AITEMS := AEDITCONTROLS [CI] [2]
                  ENDIF

                  IF LEN ( AEDITCONTROLS [CI] ) == 3
                     IF VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'A'
                        ARETURNVALUES := AEDITCONTROLS [CI] [3]
                     ENDIF
                  ENDIF

               ENDIF

               IF LEN ( AEDITCONTROLS [CI] ) == 3 ;
                  .AND. ;
                  AEC == 'SPINNER'
                  IF VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'N' ;
                     .AND. ;
                     VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'N'
                        ARANGE := { AEDITCONTROLS [CI] [2] , AEDITCONTROLS [CI] [3] }
                  ENDIF
               ENDIF

               IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
                  .AND. ;
                  AEC == 'DATEPICKER'
                  IF    VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C'
                     DTYPE := AEDITCONTROLS [CI] [2]
                  ENDIF

               ENDIF

               IF LEN ( AEDITCONTROLS [CI] ) == 3 ;
                  .AND. ;
                  AEC == 'CHECKBOX'
                  DW := -4
                  DH := -7
                  DR := 3
                  DC := 2
                  IF    VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C' ;
                     .AND. ;
                     VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'C'
                     ALABELS := { AEDITCONTROLS [CI] [2] , AEDITCONTROLS [CI] [3] }
                  ENDIF
               ENDIF

            ENDIF

         ENDIF

      ENDIF

   ENDIF

   ARET := { AEC , CTYPE , CINPUTMASK , CFORMAT , AITEMS , ARANGE , DTYPE , ALABELS , ARETURNVALUES }

RETURN ( ARET )

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA , aReturnValues )
*-----------------------------------------------------------------------------*
LOCAL BD
LOCAL VALID
LOCAL Z

   IF VALTYPE ( CVA ) = 'A'

      IF LEN ( CVA ) >= CI

         IF VALTYPE ( CVA [CI] ) = 'B'

            IF AEC == 'TEXTBOX' .or. AEC == 'EDITBOX'
               _HMG_SYSDATA [ 318 ] := GetProperty ( "_hmg_grid_inplaceedit","t","value")
            ELSEIF   AEC == 'DATEPICKER'
               _HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.d.value
            ELSEIF   AEC == 'COMBOBOX'

               IF LEN ( ARETURNVALUES ) == 0

                  _HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.c.value

               ELSE

                  _HMG_SYSDATA [ 318 ] := aReturnValues [_hmg_grid_inplaceedit.c.value ]

               ENDIF

            ELSEIF   AEC == 'SPINNER'
               _HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.s.value
            ELSEIF   AEC == 'CHECKBOX'
               _HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.c.value
            ENDIF

            _HMG_SYSDATA [ 232 ] := 'GRID_VALID'

            _DoControlEventProcedure ( CVA [CI] , _HMG_SYSDATA [ 209 ] )

            VALID := _HMG_SYSDATA [ 293 ]

            _HMG_SYSDATA [ 232 ] := ''

            IF VALID = .F.

               MSGEXCLAMATION ( _HMG_SYSDATA [ 136 ][11] )
               RETURN

            ENDIF

            redrawwindow( _HMG_SYSDATA [3] [IDX] )

         ENDIF

      ENDIF

   ENDIF

   IF _HMG_SYSDATA [ 40 ] [ idx ] [ 9 ] == .F.

      aTemp := _GetItem (  ,  , ri , idx )

   ELSE

      aTemp := array ( len( _HMG_SYSDATA [  7 ] [ idx ] ) )

      aTemp := aFill ( aTemp , '' )

      FOR Z := 1 TO LEN ( _HMG_SYSDATA [  7 ] [ idx ] )

         _HMG_SYSDATA [ 201 ] := ri // QueryRowIndex

         _HMG_SYSDATA [ 202 ] := z  // QueryColIndex

         IF valtype ( _HMG_SYSDATA [ 40 ] [ idx ] [ 10 ] ) == 'C'

            GetDataGridCellData ( idx , .t. )

         ELSE

            Eval( _HMG_SYSDATA [  6 ] [ idx ]  )

         ENDIF

         aTemp [z] := _HMG_SYSDATA [ 230 ]   // QueryData

      NEXT Z

   ENDIF

   IF AEC == 'TEXTBOX' .OR. AEC = 'EDITBOX'
      aTemp [ci] := GetProperty ( "_hmg_grid_inplaceedit","t","value")
   ELSEIF   AEC == 'DATEPICKER'
      aTemp [ci] := _hmg_grid_inplaceedit.d.value
   ELSEIF   AEC == 'COMBOBOX'

      IF LEN ( ARETURNVALUES ) == 0

         aTemp [ci] := _hmg_grid_inplaceedit.c.value

      ELSE

         aTemp [ci] := aReturnValues [_hmg_grid_inplaceedit.c.value ]

      ENDIF

   ELSEIF   AEC == 'SPINNER'
      aTemp [ci] := _hmg_grid_inplaceedit.s.value
   ELSEIF   AEC == 'CHECKBOX'
      aTemp [ci] := _hmg_grid_inplaceedit.c.value
   ENDIF

   IF _HMG_SYSDATA [ 40 ] [ idx ] [ 9 ] == .F.

      _SetItem ( , , ri , aTemp , idx )

   ENDIF

   IF valtype ( _HMG_SYSDATA [ 40 ] [ idx ] [ 10 ] ) == 'C'

      _HMG_SYSDATA [ 196 ] := ci

      SaveDataGridField ( idx , aTemp [ci] )

   endif

   _hmg_grid_inplaceedit.RELEASE

RETURN

*-----------------------------------------------------------------------------*
Procedure _HMG_SetGridCellEditValue ( arg )
*-----------------------------------------------------------------------------*

   IF ValType ( arg ) == 'C'

      If _IsControlDefined ( 't' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "t" , "value" , arg )

      EndIf

   ELSEIF   ValType ( arg ) == 'D'

      If _IsControlDefined ( 't' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "t" , "value" , arg )

      ElseIf _IsControlDefined ( 'd' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "d" , "value" , arg )

      EndIf

   ELSEIF   ValType ( arg ) == 'N'

      If _IsControlDefined ( 'c' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "c" , "value" , arg )

      ElseIf _IsControlDefined ( 's' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "s" , "value" , arg )

      ElseIf _IsControlDefined ( 't' , "_hmg_grid_inplaceedit")

         SetProperty ( "_hmg_grid_inplaceedit" , "t" , "value" , arg )

      EndIf

   ELSEIF   ValType ( arg ) == 'L'

      SetProperty ( "_hmg_grid_inplaceedit" , "c" , "value" , arg )

   ENDIF

return

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEKBDEDIT(i)
*-----------------------------------------------------------------------------*
LOCAL TmpRow
LOCAL XS
LOCAL XD
LOCAL R
LOCAL IPE_MAXCOL


   IPE_MAXCOL := Len ( _HMG_SYSDATA [ 33 ] [i] )

   Do While .T.

      TmpRow := LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] )

      If TmpRow != _HMG_SYSDATA [ 341 ]

         _HMG_SYSDATA [ 341 ] := TmpRow

         if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0
            _HMG_SYSDATA [ 340 ] := 2
         Else
            _HMG_SYSDATA [ 340 ] := 1
         EndIf

      EndIf

      _HMG_SYSDATA [ 195 ] := _HMG_SYSDATA [ 341 ]
      _HMG_SYSDATA [ 196 ] := _HMG_SYSDATA [ 340 ]

      If _HMG_SYSDATA [ 340 ] == 1
         r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
      Else
         r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
      EndIf

      xs := ( ( _HMG_SYSDATA [ 19 ] [i] + r [2] ) +( r[3] ))  -  ( _HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] )

      xd := 20

      If xs > -xd
         ListView_Scroll( _HMG_SYSDATA [3] [i] ,   xs + xd , 0 )
      Else

            If r [2] < 0
                       ListView_Scroll( _HMG_SYSDATA [3] [i] , r[2]  , 0 )
                   EndIf

      endIf

      If _HMG_SYSDATA [ 340 ] == 1
         r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
      Else
         r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
      EndIf

      _HMG_SYSDATA [ 197 ] := _HMG_SYSDATA [ 18 ] [i] + r [1]
      _HMG_SYSDATA [ 198 ] := _HMG_SYSDATA [ 19 ] [i] + r [2]
      _HMG_SYSDATA [ 199 ] := r[3]
      _HMG_SYSDATA [ 200 ] := r[4]

      *
      _HMG_SYSDATA [ 194 ] := ascan ( _HMG_SYSDATA [ 67  ] , _HMG_SYSDATA [4][i] )
      _HMG_SYSDATA [ 231 ] := 'C'
      _HMG_SYSDATA [ 203 ] := i
      _HMG_SYSDATA [ 316 ] :=  _HMG_SYSDATA [  66 ] [ _HMG_SYSDATA [ 194 ] ]
      _HMG_SYSDATA [ 317 ] :=  _HMG_SYSDATA [2] [_HMG_SYSDATA [ 203 ]]
      *

      _HMG_GRIDINPLACEEDIT(I)

      _HMG_SYSDATA [ 203 ] := 0
      _HMG_SYSDATA [ 231 ] := ''

      _HMG_SYSDATA [ 195 ] := 0
      _HMG_SYSDATA [ 196 ] := 0
      _HMG_SYSDATA [ 197 ] := 0
      _HMG_SYSDATA [ 198 ] := 0
      _HMG_SYSDATA [ 199 ] := 0
      _HMG_SYSDATA [ 200 ] := 0

      *
      _HMG_SYSDATA [ 194 ] := 0
      _HMG_SYSDATA [ 232 ] := ''
      _HMG_SYSDATA [ 316 ] :=  ''
      _HMG_SYSDATA [ 317 ] := ''
      *

      If _HMG_SYSDATA [ 256 ] == .T.

         If _HMG_SYSDATA [ 340 ] == IPE_MAXCOL

            if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0
               _HMG_SYSDATA [ 340 ] := 2
            Else
               _HMG_SYSDATA [ 340 ] := 1
            EndIf

            ListView_Scroll( _HMG_SYSDATA [3] [i] ,   -10000  , 0 )
         EndIf

         Exit

      Else

         _HMG_SYSDATA [ 340 ]++

         If _HMG_SYSDATA [ 340 ] > IPE_MAXCOL

            if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0
               _HMG_SYSDATA [ 340 ] := 2
            Else
               _HMG_SYSDATA [ 340 ] := 1
            EndIf

            ListView_Scroll( _HMG_SYSDATA [3] [i] ,   -10000  , 0 )
            Exit
         EndIf

      EndIf

   EndDo

RETURN
*------------------------------------------------------------------------------*
Function GetNumFromCellText ( Text )
*------------------------------------------------------------------------------*
Local x , c , s

   s := ''

   For x := 1 To Len ( Text )

      c := SubStr(Text,x,1)

      If c='0' .or. c='1' .or. c='2' .or. c='3' .or. c='4' .or. c='5' .or. c='6' .or. c='7' .or. c='8' .or. c='9' .or. c='.' .or. c='-'
         s := s + c
      EndIf

   Next x

   If Left ( AllTrim(Text) , 1 ) == '(' .OR.  Right ( AllTrim(Text) , 2 ) == 'DB'
      s := '-' + s
   EndIf

Return Val(s)

*------------------------------------------------------------------------------*
Function GETNumFromCellTextSP(Text)
*------------------------------------------------------------------------------*
Local x , c , s

   s := ''

   For x := 1 To Len ( Text )

      c := SubStr(Text,x,1)

      If c='0' .or. c='1' .or. c='2' .or. c='3' .or. c='4' .or. c='5' .or. c='6' .or. c='7' .or. c='8' .or. c='9' .or. c=',' .or. c='-' .or. c = '.'

         if c == '.'
            c :=''
         endif

         IF C == ','
            C:= '.'
         ENDIF

         s := s + c

      EndIf

   Next x

   If Left ( AllTrim(Text) , 1 ) == '(' .OR.  Right ( AllTrim(Text) , 2 ) == 'DB'
      s := '-' + s
   EndIf

Return Val(s)
*------------------------------------------------------------------------------*
FUNCTION _HMG_GETGRIDCELLVALUE ( CONTROLNAME , PARENTFORM , ROW , COL )
*------------------------------------------------------------------------------*
LOCAL A
LOCAL V

   A := _GetItem ( CONTROLNAME , PARENTFORM , ROW  )

   V := A [ COL ]

RETURN V
*------------------------------------------------------------------------------*
PROCEDURE _HMG_SETGRIDCELLVALUE ( CONTROLNAME , PARENTFORM , ROW , COL , CELLVALUE )
*------------------------------------------------------------------------------*
LOCAL A

   A := _GetItem ( CONTROLNAME , PARENTFORM , ROW  )

   A [ COL ] := CELLVALUE

   _SetItem ( CONTROLNAME , PARENTFORM , ROW , A )

RETURN

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_DOGRIDREFRESH(I)
*-----------------------------------------------------------------------------*
LOCAL dbc , dfc , processdbc , processdFc , COLS , ROWS , R , C , TEVAL , V
LOCAL ATEMP
LOCAL AVALUES

   dbc :=   _HMG_SYSDATA [ 40 ] [I] [3]
   processdbc := if ( valtype (dbc) = 'A' , .t. , .f. )

   dfc :=   _HMG_SYSDATA [ 40 ] [I] [4]
   processdFc := if ( valtype (dFc) = 'A' , .t. , .f. )

   IF processdbc == .F. .AND. processdFc == .F.
      RETURN
   ENDIF


   Rows := LISTVIEWGETITEMCOUNT ( _HMG_SYSDATA [3] [i] )

   Cols := Len ( _HMG_SYSDATA [  7 ] [i] )

   aTemp := ARRAY ( Rows , Cols )

   IF VALTYPE ( _HMG_SYSDATA [ 40 ] [ I ] [ 10 ] ) == 'C'

      IF processdbc

              if valtype ( _HMG_SYSDATA [40] [I] [7] ) == 'A'

            IF LEN(_HMG_SYSDATA [40] [I] [7]) != Rows

               _HMG_SYSDATA [40] [I] [7] := ARRAY ( Rows , Cols )

            ENDIF

         else

            _HMG_SYSDATA [40] [I] [7] := ARRAY ( Rows , Cols )

         endif

      ELSE

         _HMG_SYSDATA [40] [I] [7] := Nil

      ENDIF

      IF processdFc

              if valtype ( _HMG_SYSDATA [40] [I] [8] ) == 'A'

            IF LEN(_HMG_SYSDATA [40] [I] [8]) != Rows

               _HMG_SYSDATA [40] [I] [8] := ARRAY ( Rows , Cols )

            ENDIF

         else

            _HMG_SYSDATA [40] [I] [8] := ARRAY ( Rows , Cols )

         endif

      ELSE

         _HMG_SYSDATA [40] [I] [8] := Nil

      ENDIF

      Return

   ENDIF


   IF processdbc == .T.

      FOR R := 1 TO ROWS

         IF _HMG_SYSDATA [ 40 ] [ i ] [  9 ] == .T.

            aValues := _GetIVirtualItem ( R , i , Cols )

         ELSE

            aValues := _GetItem ( , , R , i )

         ENDIF


         FOR C := 1 TO COLS

            aTemp [R] [C] := -1

            _HMG_SYSDATA [ 195 ] := R
            _HMG_SYSDATA [ 196 ] := C

            _HMG_SYSDATA [ 318 ] := aValues [c]

            tEval := eval ( dbc [c] )

            IF VALTYPE ( TEVAL ) == 'A'
               IF LEN ( TEVAL ) == 3
                  TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
                  IF VALTYPE (TEVAL) = 'N'
                     aTemp [R] [C] := tEval
                  ENDIF
               ENDIF
            ENDIF

         NEXT C

      NEXT R

      _HMG_SYSDATA [40] [I] [7] := aTemp

   ELSE

      _HMG_SYSDATA [40] [I] [7] := Nil

   ENDIF

   IF processdfc == .T.

      ATEMP := ARRAY ( Rows , Cols )

      FOR R := 1 TO ROWS

         IF _HMG_SYSDATA [ 40 ] [ i ] [  9 ] == .T.

               aValues := _GetIVirtualItem ( R , i , Cols )

         ELSE

            aValues := _GetItem ( , , R , i )

         ENDIF

         FOR C := 1 TO COLS

            aTemp [R] [C] := -1

            _HMG_SYSDATA [ 195 ] := R
            _HMG_SYSDATA [ 196 ] := C

            _HMG_SYSDATA [ 318 ] := aValues [c]

            tEval := eval ( dfc [c] )

            IF VALTYPE ( TEVAL ) == 'A'
               IF LEN ( TEVAL ) == 3
                  TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
                  IF VALTYPE (TEVAL) = 'N'
                     aTemp [R] [C] := tEval
                  ENDIF
               ENDIF
            ENDIF

         NEXT C

      NEXT R

      _HMG_SYSDATA [40] [I] [8] := aTemp

   ELSE

      _HMG_SYSDATA [40] [I] [8] := Nil

   ENDIF

   RedrawWindow ( _HMG_SYSDATA [3] [i] )

RETURN

*-----------------------------------------------------------------------------*
Function _GetIVirtualItem ( nRow , i , nCols )
*-----------------------------------------------------------------------------*
Local aTemp := ARRAY ( nCols )
Local j

   For j := 1 To nCols

      _HMG_SYSDATA [ 201 ] := nRow     // This.QueryRowIndex

      _HMG_SYSDATA [ 202 ] := j     // This.QueryColIndex

      IF VALTYPE (_HMG_SYSDATA [  6 ] [ i ] ) == 'B'

         Eval( _HMG_SYSDATA [  6 ] [ i ] )   // OnQueryData Event

      ENDIF

      aTemp [j] := _HMG_SYSDATA [ 230 ]   // This.QueryData

   Next j

Return aTemp

*-----------------------------------------------------------------------------*
Function _DoGridCustomDraw ( i , a , lParam )
*-----------------------------------------------------------------------------*
Local MaxGridRows
Local MaxGridCols
Local aTemp
Local aTemp2

   MaxGridRows := LISTVIEWGETITEMCOUNT ( _HMG_SYSDATA [3] [i] )
   MaxGridCols := Len ( _HMG_SYSDATA [  7 ] [i] )

   if a[1] >= 1 .and. a[1] <= MaxGridRows .and. a[2] >= 1 .and. a[2] <= MaxGridCols
      aTemp := _HMG_SYSDATA [40] [I] [7]
      aTemp2 := _HMG_SYSDATA [40] [I] [8]

      if valtype ( aTemp ) = 'A' .and. valtype ( aTemp2 ) <> 'A'
         if len ( aTemp ) >= a[1]
            if aTemp [a[1]] [a[2]] <> -1
               Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , RGB(0,0,0) )
            else
               Return SETBRCCD(LpARAM)
            endif
         else
            Return SETBRCCD(LpARAM)
         endif
      elseif valtype ( aTemp ) <> 'A' .and. valtype ( aTemp2 ) = 'A'
         if len ( aTemp2 ) >= a[1]
            if aTemp2 [a[1]] [a[2]] <> -1
               Return SetBcBc ( lParam , RGB(255,255,255) , aTemp2 [a[1]] [a[2]] )
            else
               Return SETBRCCD(LpARAM)
            endif
         else
            Return SETBRCCD(LpARAM)
         endif
      elseif valtype ( aTemp ) = 'A' .and. valtype ( aTemp2 ) = 'A'

         if len ( aTemp ) >= a[1] .and. len ( aTemp2 ) >= a[1]
            if aTemp [a[1]] [a[2]] <> -1

               *msginfo( str (aTemp [a[1]] [a[2]]) + ' * ' + str(aTemp2 [a[1]] [a[2]]) )

               Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , aTemp2 [a[1]] [a[2]] )
            else
               Return SETBRCCD(LpARAM)
            endif
         else
            Return SETBRCCD(LpARAM)
         endif
      endif
   else

      Return SETBRCCD(LpARAM)

   endif

Return 0

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEKBDEDIT_2(i)
*-----------------------------------------------------------------------------*
LOCAL TmpRow
LOCAL XS
LOCAL XD
LOCAL R
LOCAL IPE_MAXCOL
LOCAL S
Local aColumnWhen := _HMG_SYSDATA [ 40 ] [ i ] [  6 ]
Local j
Local nWhenRow
Local xTmpCellValue
Local aTemp

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
Local nStart  := 0
Local nEnd    := 0
Local lResult := .T.
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

//Problem3031

   _HMG_GRID_KBDSCROLL(I)

   If _HMG_SYSDATA [ 15 ] [i] == 1
      r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 39 ] [i] - 1 )
   Else
      r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 39 ] [i]- 1 , _HMG_SYSDATA [ 15 ] [i] - 1 )
   EndIf

   nWhenRow := _HMG_SYSDATA [ 195]

   _HMG_SYSDATA [ 197 ] := _HMG_SYSDATA [ 18 ] [i] + r [1]
   _HMG_SYSDATA [ 198 ] := _HMG_SYSDATA [ 19 ] [i] + r [2]
   _HMG_SYSDATA [ 199 ] := r[3]
   _HMG_SYSDATA [ 200 ] := r[4]

   *
   _HMG_SYSDATA [ 194 ] := ascan ( _HMG_SYSDATA [ 67  ] , _HMG_SYSDATA [4][i] )
   _HMG_SYSDATA [ 231 ] := 'C'
   _HMG_SYSDATA [ 203 ] := i
   _HMG_SYSDATA [ 316 ] :=  _HMG_SYSDATA [  66 ] [ _HMG_SYSDATA [ 194 ] ]
   _HMG_SYSDATA [ 317 ] :=  _HMG_SYSDATA [2] [_HMG_SYSDATA [ 203 ]]
   *

   S := _HMG_GRIDINPLACEEDIT(I)

   IF _HMG_SYSDATA [ 32 ] [I] .AND. _HMG_SYSDATA [ 245 ] == .F.

      IF   _HMG_SYSDATA [ 15 ] [I] < LEN(_HMG_SYSDATA [  7 ] [I])

         IF _HMG_SYSDATA [ 40 ] [ I ] [ 32 ] == 0

                 IF S

               IF .NOT. _HMG_SYSDATA [ 285 ]
*!!!!
                  IF _HMG_SYSDATA [ 284 ]
                     IF .NOT. _HMG_SYSDATA [ 256 ]
                        InsertDown()
                        InsertReturn()
                     ENDIF
                  ELSE
                     _HMG_SYSDATA [ 15 ] [I]++
                  ENDIF

               ELSE

                  _HMG_SYSDATA [ 15 ] [I]++
                  _HMG_SYSDATA [ 285 ] := .F.
                  InsertReturn()

               ENDIF


               If ValType ( aColumnWhen ) == 'A'

                  nStart := _HMG_SYSDATA [ 15 ] [I]

                  nEnd := Len ( aColumnWhen )

                  For j := nStart To nEnd

                     If ValType ( aColumnWhen [j] ) == 'B'

*******************************************************************************************************************************
                        IF _HMG_SYSDATA [ 40 ] [ i ] [ 9 ] == .F.
                           aTemp := this.item( nWhenRow )
                           xTmpCellValue := aTemp [j]
                        ELSE
                           _HMG_SYSDATA [ 201 ] := nWhenRow // QueryRowIndex
                           _HMG_SYSDATA [ 202 ] := j   // QueryColIndex
                           _HMG_SYSDATA [ 320 ] := .T.
                           IF valtype ( _HMG_SYSDATA [ 40 ] [ i ] [ 10 ] ) == 'C'
                              GetDataGridCellData ( i , .t. )
                           ELSE
                              Eval( _HMG_SYSDATA [  6 ] [ i ]  )
                           ENDIF
                           _HMG_SYSDATA [ 320 ] := .F.
                           xTmpCellValue := _HMG_SYSDATA [ 230 ]
                        ENDIF
********************************************************************************************************************************

                        _HMG_SYSDATA [ 318 ] := xTmpCellValue

                        _HMG_SYSDATA [ 232 ] := 'GRID_WHEN'

                        lResult := Eval ( aColumnWhen [j] )

                        _HMG_SYSDATA [ 232 ] := ''

                        If lResult == .F.

                           _HMG_SYSDATA [ 15 ] [I]++

                        Else

                           Exit

                        EndIf

                     EndIf

                  Next j

                  IF .NOT. _HMG_SYSDATA [ 284 ]

                                                   IF _HMG_SYSDATA [ 15 ] [I] > nEnd

                        _HMG_SYSDATA [ 15 ] [I] := nStart - 1

                     ENDIF

                  ENDIF

               EndIf

            ENDIF

         ENDIF

      ELSEIF _HMG_SYSDATA [ 15 ] [I] == LEN(_HMG_SYSDATA [  7 ] [I])

         IF _HMG_SYSDATA [ 40 ] [ I ] [ 32 ] == 0

                 IF S

               IF .NOT. _HMG_SYSDATA [ 285 ]

                  IF .NOT. _HMG_SYSDATA [ 284 ]
                     _HMG_SYSDATA [ 15 ] [I] := 1
                  ELSE
                     IF .NOT. _HMG_SYSDATA [ 256 ]
                        InsertDown()
                        InsertReturn()
                     ENDIF
                  ENDIF

               ELSE

                  _HMG_SYSDATA [ 15 ] [I] := 1
                  _HMG_SYSDATA [ 285 ] := .F.

               ENDIF

            ENDIF

         ENDIF

      ENDIF

      LISTVIEW_REDRAWITEMS( _HMG_SYSDATA[3][I] , _HMG_SYSDATA[39][I]-1 , _HMG_SYSDATA[39][I]-1 )
      _DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [i] , i )

   ENDIF

   _HMG_SYSDATA [ 203 ] := 0
   _HMG_SYSDATA [ 231 ] := ''

   _HMG_SYSDATA [ 195 ] := 0
   _HMG_SYSDATA [ 196 ] := 0
   _HMG_SYSDATA [ 197 ] := 0
   _HMG_SYSDATA [ 198 ] := 0
   _HMG_SYSDATA [ 199 ] := 0
   _HMG_SYSDATA [ 200 ] := 0

   *
   _HMG_SYSDATA [ 194 ] := 0
   _HMG_SYSDATA [ 232 ] := ''
   _HMG_SYSDATA [ 316 ] :=  ''
   _HMG_SYSDATA [ 317 ] := ''
   *

RETURN

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRID_KBDSCROLL(I)
*-----------------------------------------------------------------------------*

LOCAL R ,XS , XD



   _HMG_SYSDATA [ 195 ] := _HMG_SYSDATA [ 39 ] [i]
   _HMG_SYSDATA [ 196 ] := _HMG_SYSDATA [ 15 ] [i]



   If _HMG_SYSDATA [ 15 ] [i] == 1
      r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 39 ] [i] - 1 )
   Else
      r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 39 ] [i] - 1 , _HMG_SYSDATA [ 15 ] [i] - 1 )
   EndIf

   xs := ( ( _HMG_SYSDATA [ 19 ] [i] + r [2] ) +( r[3] ))  -  ( _HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] )

   xd := 20

   If xs > -xd
      ListView_Scroll( _HMG_SYSDATA [3] [i] ,   xs + xd , 0 )
   Else

            If r [2] < 0
                       ListView_Scroll( _HMG_SYSDATA [3] [i] , r[2]  , 0 )
                EndIf

   endIf

RETURN



***********************
Function IsDataGridMemo ( index , Col )
***********************
Local cRecordSource := ''
Local aColumnFields := {}
local lRet

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]
   aColumnFields  := _HMG_SYSDATA [ 40 ] [ index ] [ 11 ]

   if Type ( cRecordSource + '->' + aColumnFields[ Col ] ) == 'M'

      lRet := .t.

   else

      lRet := .f.

   endif

Return lRet

Function IsDataGridDeleted ( index , nRow )
Local cRecordSource
local lRet
local xRecNo

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]

   xRecNo := &cRecordSource->( recno() )

   &cRecordSource->(OrdKeyGoTo(nRow))

   if &cRecordSource->(deleted())

      lRet := .t.

   else

      lRet := .f.

   endif

   &cRecordSource->( dbGoTo( xRecNo ) )

Return lRet





***********
function setdatagridrecno ( i , nRecNo  )
***

Local aValue
Local nLogicalPos := 0
Local j := 1
Local lOk := .f.

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
Local cRecordSource  := _HMG_SYSDATA [ 40 ] [ i ] [ 10 ]
Local nBakReNo := &cRecordSource->(RecNo())
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

   aValue := _GetValue (  ,  ,  i )

   if ( empty ( &cRecordSource->( dbFilter () ) ) ) .and. ( .Not. Set ( _SET_DELETED ) ) .and. ( empty ( &cRecordSource->( ordfor() ) ) )

      lOk := .t.

      &cRecordSource->( dbGoTo ( nRecNo ) )
      nLogicalPos := &cRecordSource->( OrdKeyNo () )

   else

      lOk := .f.

      nLogicalPos := 1

      &cRecordSource->( dbGoTop() )

      Do While .Not. Eof()

         If &cRecordSource->( Recno() ) == nRecNo

            lOk := .t.
            Exit

         EndIf

         &cRecordSource->( dbSkip() )
         nLogicalPos++

      EndDo

   endif

   &cRecordSource->( DbGoTo ( nBakReNo ) )

   If lOk

      _SetValue (  ,  ,  {  nLogicalPos , aValue [2] } , i )

   EndIf

return nil

***********
function getdatagridrecno(i)
***

Local cRecordSource := ''
Local nItemCount
Local nHandle
Local aColumnFields := {}
Local lRet := .T.
Local j
Local aValue
Local nLogicalPos
Local nRecNo
Local nTopIndex
Local nBakReNo

Local aTemp
Local nBuffLogicalRow
Local nBuffPhysicalRow
Local k



   cRecordSource  := _HMG_SYSDATA [ 40 ] [ i ] [ 10 ]

   aColumnFields  := _HMG_SYSDATA [ 40 ] [ i ] [ 11 ]

   nHandle     := _HMG_SYSDATA [ 3 ] [ i ]

   nBakReNo := &cRecordSource->(RecNo())

   aValue := _GetValue (  ,  ,  i )


   if ( empty ( &cRecordSource->( dbFilter () ) ) ) .and. ( .Not. Set ( _SET_DELETED ) )

      &cRecordSource->( OrdKeyGoTo ( aValue[1] ) )

   else

      &cRecordSource->( dbGoTop() )

      &cRecordSource->( dbSkip( aValue[1] - 1 ) )

   endif


   If &cRecordSource->(eof())

      nRecNo := 0

      * Try to get the buffer record number (if available)

      aTemp := _HMG_SYSDATA [ 40 ] [ i ] [21]

      For k := 1 To Len ( aTemp )

         * Get Buffer Data

         nBuffLogicalRow := aTemp [ k ] [ 1 ]

         nBuffPhysicalRow := aTemp [ k ] [ 4 ]

         If nBuffLogicalRow == _HMG_SYSDATA [ 39 ] [i]

            nRecNo := nBuffPhysicalRow

            Exit

         EndIf

      Next k

   Else

      nRecNo := &cRecordSource->(RecNo())

   EndIf


   &cRecordSource->( DbGoTo ( nBakReNo ) )

return nRecNo


***********************
Procedure GetDataGridCellData ( index , lTrueData )
***********************
Local nDelta
Local tEval

Local aTemp
Local nLength
Local lBufferedCell := .F.
Local nCurrentPhysicalRecord := 0
Local lBufferedDeletedRow := .F.
Local lBufferedRecalledRow := .F.
Local cRecordSource := ''
Local aColumnFields := {}
Local aColumnClassMap := {}

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
Local x := 0
Local xBufferedCellValue, xEval
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

Static nPrevPhysicalRecord := 0
Static nPrevLogicalRecord := 1
Static nLastHandle := 0

   IF _HMG_SYSDATA [ 347 ] == .F.
      RETURN
   ENDIF

   IF _HMG_SYSDATA [ 40 ] [ index ] [ 33 ] == .F.
      RETURN
   ENDIF

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]
   aColumnFields  := _HMG_SYSDATA [ 40 ] [ index ] [ 11 ]
   aColumnClassMap := _HMG_SYSDATA [ 40 ] [ index ] [ 30 ]

   If nLasthandle == _HMG_SYSDATA [3] [ Index ]

      // If record pointer was moved externally it must be adjusted
      // to avoid terrible things to happen :)

      if nPrevPhysicalRecord != &cRecordSource->( recno() )
         if nPrevPhysicalRecord != 0
            &cRecordSource->(  dbGoTo ( nPrevPhysicalRecord ) )
         endif
      endif

      //// Begin Trick to do less calls to OrdKeyGoTo() !

      nDelta := This.QueryRowIndex - nPrevLogicalRecord

      if nDelta != 0

         if abs ( nDelta ) < _HMG_SYSDATA [ 40 ] [ index ] [ 27 ]
            &cRecordSource->( dbSkip(nDelta) )
         else
            &cRecordSource->(OrdKeyGoTo (This.QueryRowIndex))
         endif

         nPrevLogicalRecord := This.QueryRowIndex
         nPrevPhysicalRecord := &cRecordSource->( recno() )

      endif

      /// End Trick :)

   Else

      nLasthandle := _HMG_SYSDATA [3] [ Index ]

      &cRecordSource->(OrdKeyGoTo (This.QueryRowIndex))

      nPrevLogicalRecord := This.QueryRowIndex
      nPrevPhysicalRecord := &cRecordSource->( recno() )

   EndIf


   * Determine If The Required Cell Is Buffered

   IF _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] == .T.

      aTemp := _HMG_SYSDATA [ 40 ] [ index ] [21]
      nLength := len ( aTemp )
      lBufferedCell := .F.

      FOR X := 1 TO nLength

         IF  aTemp [ x ] [ 1 ] == This.QueryRowIndex .and. aTemp [ x ] [ 2 ] == This.QueryColIndex

            lBufferedCell := .T.
            xBufferedCellValue := aTemp [ x ] [ 3 ]

            Exit

         ENDIF

      NEXT X


      * Process Deleted Rows

      aTemp   := _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] // Delete / Recall Buffer Array { nLogicalRow , nPhysicalRow , cStatus ( 'D' or 'R' ) }
      nLength := _HMG_SYSDATA [ 40 ] [ index ] [ 24 ] // Deleted / Recalled record count

      lBufferedDeletedRow := .F.
      lBufferedRecalledRow := .F.

      For x := 1 To nLength

         IF  aTemp [ x ] [ 1 ] == This.QueryRowIndex .and. aTemp [ x ] [ 3 ] == 'D'

            lBufferedDeletedRow := .T.
            Exit

         EndIf

         IF  aTemp [ x ] [ 1 ] == This.QueryRowIndex .and. aTemp [ x ] [ 3 ] == 'R'

            lBufferedRecalledRow := .T.
            Exit

         EndIf

      Next x

   ENDIF

   * This started like a nice and compact piece of code, but it is becoming
   * terribly complicated now :)

   if Type ( cRecordSource + '->' + aColumnFields[ This.QueryColIndex ] ) == 'M'

      If lTrueData

         If lBufferedCell

            This.QueryData := xBufferedCellValue

         else

            This.QueryData := &cRecordSource->&( aColumnFields[ This.QueryColIndex ] )

         endif

      else

         This.QueryData := '<memo>'

      EndIf

   else

      If lTrueData

         If lBufferedCell

            This.QueryData := xBufferedCellValue

         Else

*******************************************************************************
            if aColumnClassMap[ This.QueryColIndex ] == 'F'

               This.QueryData := &cRecordSource->&( aColumnFields[ This.QueryColIndex ] )

            Else

               This.QueryData := &( aColumnFields[ This.QueryColIndex ] )

            EndIf
*******************************************************************************

         EndIf

      else

         If ValType ( _HMG_SYSDATA [ 40 ] [ index ] [ 18 ] ) = 'A' // DynamicDisplay

            _HMG_SYSDATA [ 195 ] := This.QueryRowIndex
            _HMG_SYSDATA [ 196 ] := This.QueryColIndex

            IF _HMG_SYSDATA [ 40 ] [ index ] [ 15 ] == .T. .AND. _HMG_SYSDATA [ 40 ] [ index ] [ 14 ] == .T.

               IF This.QueryRowIndex == LISTVIEWGETITEMCOUNT( _HMG_SYSDATA [3] [ index ] )

                  _HMG_SYSDATA [ 318 ] := _HMG_SYSDATA [ 40 ] [ index ] [ 13 ] [ This.QueryColIndex ]

               ELSE

                  If lBufferedCell

                     _HMG_SYSDATA [ 318 ] := xBufferedCellValue

                  Else

                     _HMG_SYSDATA [ 318 ] := &cRecordSource->&( aColumnFields[ This.QueryColIndex ] )

                  EndIf

               ENDIF

            ELSE

               If lBufferedCell

                  _HMG_SYSDATA [ 318 ] := xBufferedCellValue

               Else

*******************************************************************************

                  if aColumnClassMap[ This.QueryColIndex ] == 'F'

                     _HMG_SYSDATA [ 318 ] := &cRecordSource->&( aColumnFields[ This.QueryColIndex ] )

                  Else

                     _HMG_SYSDATA [ 318 ] := &( aColumnFields[ This.QueryColIndex ] )


                  EndIf

*******************************************************************************

               EndIf

            ENDIF

            tEval := eval ( _HMG_SYSDATA [40] [index] [18] [This.QueryColIndex] )

            This.QueryData := tEval

         Else

            If lBufferedCell

               This.QueryData := xBufferedCellValue

            Else

*******************************************************************************


               if aColumnClassMap [ This.QueryColIndex ] == 'F'

                  This.QueryData := &cRecordSource->&( aColumnFields[ This.QueryColIndex ] )

               else

                  This.QueryData := &( aColumnFields[ This.QueryColIndex ] )

               endif

*******************************************************************************

            EndIf

         EndIf

      Endif

   Endif


   * Process deleted style and dynamic forecolor

   if valtype ( _HMG_SYSDATA [40] [index] [8] ) == 'A'

      if _HMG_SYSDATA [ 40 ] [ index ] [ 16 ] == .F. // Process Deleted

         if ( &cRecordSource->( deleted() ) .Or. lBufferedDeletedRow ) .and. ( ! lBufferedRecalledRow )

            IF LEN ( _HMG_SYSDATA [40] [index] [8] ) >= This.QueryRowIndex

               _HMG_SYSDATA [40] [index] [8] [This.QueryRowIndex] [This.QueryColIndex] := RGB ( 225 , 225 , 225 )

            ENDIF

         else

            IF LEN ( _HMG_SYSDATA [40] [index] [8] ) >= This.QueryRowIndex

               _HMG_SYSDATA [40] [index] [8] [This.QueryRowIndex] [This.QueryColIndex] := RGB ( 0 , 0 , 0 )

            ENDIF

         endif

      else // Process DynamicForeColor

         IF LEN ( _HMG_SYSDATA [40] [index] [8] ) >= This.QueryRowIndex

            _HMG_SYSDATA [40] [index] [8] [This.QueryRowIndex] [This.QueryColIndex] := -1

         ENDIF

         _HMG_SYSDATA [ 195 ] := This.QueryRowIndex
         _HMG_SYSDATA [ 196 ] := This.QueryColIndex

         If lBufferedCell

            _HMG_SYSDATA [ 318 ] := xBufferedCellValue

         Else

            _HMG_SYSDATA [ 318 ] := This.QueryData

         EndIf

         tEval := eval ( _HMG_SYSDATA [40] [index] [4] [This.QueryColIndex] )

         IF VALTYPE ( TEVAL ) == 'A'
            IF LEN ( TEVAL ) == 3
               TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
               IF VALTYPE (TEVAL) = 'N'

                  IF LEN ( _HMG_SYSDATA [40] [index] [8] ) >= This.QueryRowIndex

                     _HMG_SYSDATA [40] [index] [8] [This.QueryRowIndex] [This.QueryColIndex] := tEval

                  ENDIF

               ENDIF
            ENDIF
         ENDIF

      endif

   endif

   if valtype ( _HMG_SYSDATA [40] [index] [7] ) == 'A'

      // Process DynamicBackColor

      IF LEN ( _HMG_SYSDATA [40] [index] [7] ) >= This.QueryRowIndex

         _HMG_SYSDATA [40] [index] [7] [This.QueryRowIndex] [This.QueryColIndex] := -1

      ENDIF

      _HMG_SYSDATA [ 195 ] := This.QueryRowIndex
      _HMG_SYSDATA [ 196 ] := This.QueryColIndex
      _HMG_SYSDATA [ 318 ] := This.QueryData

      xEval := eval ( _HMG_SYSDATA [40] [index] [3] [This.QueryColIndex] )

      IF VALTYPE ( xEVAL ) == 'A'
         IF LEN ( xEVAL ) == 3
            xEVAL := RGB ( xEVAL [1] , xEVAL [2] , xEVAL [3] )
            IF VALTYPE (xEVAL) = 'N'

               IF LEN ( _HMG_SYSDATA [40] [index] [7] ) >= This.QueryRowIndex

                  _HMG_SYSDATA [40] [index] [7] [This.QueryRowIndex] [This.QueryColIndex] := xEval

               ENDIF

            ENDIF
         ENDIF
      ENDIF

   endif

Return

************************
Function DataGridDelete ( index )
************************
Static cRecordSource := ''
Static aColumnFields := {}

Local cOperation
Local nLogicalRow
Local nPhysicalRow
Local x


   * Set Operation Type

   cOperation := 'D'


   * Get Logical Row

   nLogicalRow := _HMG_SYSDATA [ 39 ] [index]


   * Get Physical Row

   nPhysicalRow := GetDataGridRecNo(index)


   * Process Double-Deleted/Recalled

   For x := 1 To _HMG_SYSDATA [ 40 ] [ index ] [ 24 ]

      If _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] [ x ] [ 1 ] == nLogicalRow

         _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] [ x ] [ 3 ] := 'D'

         Return .T.

      EndIf

   Next x


   * Not Double Deleted/Recalled *********************************************


   * Append Record To Deleted / Recalled Buffer

   aadd ( _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] , { nLogicalRow , nPhysicalRow , cOperation } )


   * Update Deleted / Recalled Buffer Count

   _HMG_SYSDATA [ 40 ] [ index ] [ 24 ]++


   * Set Pending Updates Flag

   _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] := .T.


Return .T.

************************
Function DataGridRecall ( index )
************************

Local cOperation
Local nLogicalRow
Local nPhysicalRow
Local x

Static cRecordSource := ''
Static aColumnFields := {}



   * Set Operation Type

   cOperation := 'R'


   * Get Logical Row

   nLogicalRow := _HMG_SYSDATA [ 39 ] [index]


   * Get Physical Row

   nPhysicalRow := GetDataGridRecNo(index)


   * Process Double-Deleted/Recalled

   For x := 1 To _HMG_SYSDATA [ 40 ] [ index ] [ 24 ]

      If _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] [ x ] [ 1 ] == nLogicalRow

         _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] [ x ] [ 3 ] := 'R'

         Return .T.

      EndIf

   Next x


   * Not Double Deleted/Recalled *******************************************


   * Append Record To Deleted / Recalled Buffer

   aadd ( _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] , { nLogicalRow , nPhysicalRow , cOperation } )


   * Update Deleted / Recalled Buffer Count

   _HMG_SYSDATA [ 40 ] [ index ] [ 24 ]++


   * Set Pending Updates Flag

   _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] := .T.


Return .T.

Function IsDataGridFiltered ( index )
Local cRecordSource
local lRet
local xRecNo

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]

   xRecNo := &cRecordSource->( recno() )

   if ( .not. empty ( &cRecordSource->( dbfilter() ) ) ) .or. Set ( _SET_DELETED ) .or. ( .not. empty ( &cRecordSource->( ordfor( indexord() ) ) ) )

      lRet := .t.

   else

      lRet := .f.

   endif

   &cRecordSource->( dbGoTo( xRecNo ) )

Return lRet

Function GetDataGridRecCount()
Local nCount
Local nInitialRecord

   nInitialRecord := RecNo()

   COUNT TO nCount

   dbGoTo( nInitialRecord )

Return nCount


************************
Function SaveDataGridField ( index , Value )
************************

Local nLogicalRow
Local nLogicalCol
Local lReEdit := .F.
Local aTemp := {}
Local nBufferRow
Local x

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
LOCAL nRecNo := 0
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

   * Get Logical Position

   nLogicalRow := _HMG_SYSDATA [ 39 ] [index]
   nLogicalCol := _HMG_SYSDATA [ 15 ] [index]


   * Get Selected Row Record Number

   nRecNo := GetDataGridRecNo(index)

   If nRecNo == 0 && New Buffered Record Without a True RecNo

      nRecNo := _HMG_SYSDATA [ 40 ] [ index ] [ 23 ] - nLogicalRow

   EndIf

   * Is re-edit of the same cell ?

   If _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] == .T.

      aTemp := _HMG_SYSDATA [ 40 ] [ index ] [21]

      For x := 1 To Len ( aTemp )

         If aTemp [ x ] [ 1 ] == nLogicalRow

            If aTemp [ x ] [ 2 ] == nLogicalCol

               lReEdit := .T.
               nBufferRow := x
               Exit

            EndIf

         EndIf

      Next x

   EndIf


   * Add Data to Pending Updates Buffer

   If lReEdit

      _HMG_SYSDATA [ 40 ] [ index ] [21] [ nBufferRow ] := { nLogicalRow , nLogicalCol , Value , nRecNo }

   Else

      aadd ( _HMG_SYSDATA [ 40 ] [ index ] [21] , { nLogicalRow , nLogicalCol , Value , nRecNo } )

   EndIf


   * Set Pending Updates Flag

   _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] := .T.


Return .T.



*****************
Function DataGridAppend(i)
******

Local cRecordSource := ''
Local nItemCount
Local nHandle
Local aColumnFields := {}
Local lRet := .T.
Local j

   * Get Control Data

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ i ] [ 10 ]
   aColumnFields  := _HMG_SYSDATA [ 40 ] [ i ] [ 11 ]
   nHandle     := _HMG_SYSDATA [ 3 ] [ i ]
   nItemCount  := ListViewGetItemCount ( nHandle )


   * Append a Row To The Grid

   ListView_SetItemCount ( nHandle , 0 )
   ListView_SetItemCount ( nHandle , nItemCount + 1 )

   &cRecordSource->(dbGoTop())
   &cRecordSource->(dbGoBottom())

   nItemCount  := ListViewGetItemCount ( nHandle )

   _Setvalue ( , , { nItemCount , 1 } , i )


   * Adjust Dynamic BackColor and Dynamic Forecolor Arrays

   aadd ( _HMG_SYSDATA [40] [ i ] [8] , array ( len( aColumnFields ) ) )

   IF VALTYPE ( _HMG_SYSDATA [40] [ i ] [7] ) == 'A'

      aadd ( _HMG_SYSDATA [40] [ i ] [7] , array ( len( aColumnFields ) ) )

   ENDIF


   * Update New Record Buffer Count (Negative)

   _HMG_SYSDATA [ 40 ] [ i ] [ 22 ]--


   * Set Default Values For The New Record

   for j := 1 to len ( _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] )

      if type ( aColumnFields [j] ) == 'C'

         _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] := ''

      elseif   type ( aColumnFields [j] ) == 'N'

         _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] := 0

      elseif   type ( aColumnFields [j] ) == 'D'

         _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] := ctod('  /  /  ')

      elseif   type ( aColumnFields [j] ) == 'L'

         _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] := .F.

      elseif   type ( aColumnFields [j] ) == 'M'

         _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] := ''

      endif

      aadd ( _HMG_SYSDATA [ 40 ] [ i ] [21] , { nItemCount , j , _HMG_SYSDATA [ 40 ] [ i ] [ 13 ] [j] , _HMG_SYSDATA [ 40 ] [ i ] [ 22 ] } )

   next j


   * Set Pending Updates Flag

   _HMG_SYSDATA [ 40 ] [ i ] [ 20 ] := .T.


Return lRet

*****************
Function DataGridSave(i)
******

Local x
Local z
Local n
Local l
Local j
Local k
Local aTemp
Local aValue
Local f
Local g
Local h
Local aAppendBuffer
Local aEditBuffer
Local aMarkBuffer
Local nColumnCount
Local nAppendRecordCount
Local aRecord
Local aColumnClassMap

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
LOCAL cRecordSource := ''
LOCAL cCommand      := ''
LOCAL aColumnFields := {}
LOCAL nHandle := 0
LOCAL nRecNo := 0
LOCAL nItemCount := 0
LOCAL nLogicalCol := 0
LOCAL nLogicalRow := 0
LOCAL xValue := 0
LOCAL nPhysicalRow := 0
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

   * If Not Buffered Data Then Return ************************************

   If _HMG_SYSDATA [ 40 ] [ i ] [ 20 ] == .F.

      Return .F.

   EndIf


   * Get Control Data ****************************************************

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ i ] [ 10 ]
   aColumnFields  := _HMG_SYSDATA [ 40 ] [ i ] [ 11 ]
   aColumnClassMap := _HMG_SYSDATA [ 40 ] [ i ] [ 30 ]
   nHandle     := _HMG_SYSDATA [ 3 ] [ i ]
   nItemCount  := ListViewGetItemCount ( nHandle )

   * Backup Record Number ************************************************

   nRecNo := &cRecordSource->(recno())


   * If OnSave Specified, Process It And Exit ****************************

   If ValType ( _HMG_SYSDATA [ 40 ] [ i ] [ 26 ] ) == 'B'


      * Create User Buffer Arrays From Internal Ones ****************

      aAppendBuffer  := {}
      aEditBuffer := {}
      aMarkBuffer := _HMG_SYSDATA [ 40 ] [ i ] [ 25 ]

      aTemp := _HMG_SYSDATA [ 40 ] [ i ] [21] // Internal Buffer

      nColumnCount := len ( aColumnFields )

      nAppendRecordCount := _HMG_SYSDATA [ 40 ] [ i ] [ 22 ]


      * Create User Append Buffer ***********************************

      for h := -1 To nAppendRecordCount Step -1

         aRecord := array ( nColumnCount )

         for g := 1 To len ( aTemp )

            if aTemp [ g ] [ 4 ] == h

               aRecord [ aTemp [ g ] [ 2 ] ] := aTemp [ g ] [ 3 ]

            endif

         next g

         aadd ( aAppendBuffer , aRecord )

      next h


      * Create User Edit Buffer *******************************************

      for g := 1 To len ( aTemp )

         h := aTemp [ g ] [ 4 ]

         if h > 0

            aadd ( aEditBuffer , aTemp [ g ] )

         endif

      next g


      * Set This.*Buffer Properties

      _HMG_SYSDATA [ 278 ] := aClone ( aEditBuffer )
      _HMG_SYSDATA [ 279 ] := aClone ( aMarkBuffer )
      _HMG_SYSDATA [ 280 ] := aClone ( aAppendBuffer )


      * Execute It!

      Eval ( _HMG_SYSDATA [ 40 ] [ i ] [ 26 ] )


      * Cleanup ********************************************


      * Set Pending Updates Flag *

      _HMG_SYSDATA [ 40 ] [ i ] [ 20 ] := .F.


      * Clean Data Buffer *

      _HMG_SYSDATA [ 40 ] [ i ] [21] := {}


      * Update New Records Buffer Count *

      _HMG_SYSDATA [ 40 ] [ i ] [ 22 ] := 0


      * Reset Buffered Session Initial Item Count *

      _HMG_SYSDATA [ 40 ] [ i ] [ 23 ] := &cRecordSource->(GetDataGridRecCount())


      * Reset Deleted / Recalled Buffer Count *

      _HMG_SYSDATA [ 40 ] [ i ] [ 24 ] :=  0


      * Reset Deleted / Recalled Buffer *

      _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] := {}


      * Refresh

      DataGridRefresh(i)


      * The End

      Return .T.


   EndIf



   ///////////////////////////////////////////////////////////////////////
   // RDD DEPENDANT CODE
   ///////////////////////////////////////////////////////////////////////


   if &cRecordSource->(RddName()) == 'SQLMIX'

      MsgHMGError("GRID: Modify SQLMIX RDD tables are not allowed. Program terminated" )

   ElseIf   &cRecordSource->(RddName()) == 'PGRDD'

      MsgHMGError("GRID: Modify PostGre RDD tables are not allowed. Program terminated" )

   Else

      _HMG_SYSDATA [347] := .F.

      * Process Existing Records *************************************************

      aTemp := _HMG_SYSDATA [ 40 ] [ i ] [21]

      For x := 1 To Len ( aTemp )


         * Get Buffer Data

         nLogicalRow := aTemp [ x ] [ 1 ]

         nLogicalCol := aTemp [ x ] [ 2 ]

         xValue   := aTemp [ x ] [ 3 ]

         nPhysicalRow := aTemp [ x ] [ 4 ]


         * Position in Physical Row ..............

         If nPhysicalRow > 0


            &cRecordSource->( dbGoTo ( nPhysicalRow ) )


            * Attempt To Lock To Save ....................................

            If Rlock() == .F.
               MsgExclamation(_HMG_SYSDATA [ 136 ][9],_HMG_SYSDATA [ 136 ][10])
               &cRecordSource->(dbgoto(nRecNo))
               Return .f.
            endif


            * Save Data ..................................................

*******************************************************************************

            if aColumnClassMap[ nLogicalCol ] == 'F'

               &cRecordSource->&( aColumnFields[ nLogicalCol ] ) := xValue

            Else

               &( aColumnFields[ nLogicalCol ] ) := xValue

            EndIf

*******************************************************************************

            * Unlock .....................................................

            &cRecordSource->(dbrUnlock(&cRecordSource->(recno())))


         EndIf

      Next x


      * Process New Records ************************************************


      l := Len(aTemp)

      For z := 1 To l

         If aTemp [ z ] [ 4 ] < 0

            * If the new record is marked as 'Deleted'
            * do not append.

            If ! IsBufferedRecordMarkedForDeletion( i , aTemp [ z ] [ 4 ] )

               &cRecordSource->(dbAppend( ) )

               n := aTemp [ z ] [ 4 ]

               For j := 1 To l

                  If aTemp [j] [4] == n


                     * Attempt To Lock To Save .............

                     If Rlock() == .F.
                        MsgExclamation(_HMG_SYSDATA [ 136 ][9],_HMG_SYSDATA [ 136 ][10])
                        &cRecordSource->(dbgoto(nRecNo))
                        Return .f.
                     endif


                     * Save Data ...........................

*******************************************************************************

                     if aColumnClassMap[ aTemp [j] [2] ] == 'F'

                        &cRecordSource->&( aColumnFields[ aTemp [j] [2] ] ) := aTemp [j] [3]

                     EndIf

*******************************************************************************

                     * Unlock ..............................

                     &cRecordSource->(dbrUnlock(&cRecordSource->(recno())))


                     * CleanUp .............................

                     aTemp [j] [1] := 0
                     aTemp [j] [2] := 0
                     aTemp [j] [3] := Nil
                     aTemp [j] [4] := 0

                     Endif

               Next j

            EndIf

         EndIf

      Next z


      * Precess Delete / ReCall Commands ****************************


      For k := 1 To _HMG_SYSDATA [ 40 ] [ i ] [ 24 ]


         * Get Row And Command

         nPhysicalRow := _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] [ k ] [ 2 ]

         cCommand := _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] [ k ] [ 3 ]


         * Position On The Record To Process

         &cRecordSource->( dbGoTo( nPhysicalRow ) )


         * Lock Record

         If Rlock() == .F.
            MsgExclamation(_HMG_SYSDATA [ 136 ][9],_HMG_SYSDATA [ 136 ][10])
            return .f.
         endif


         * Excute Command **************************************

         If cCommand == 'D'

            &cRecordSource->( dbDelete() )

         ElseIf cCommand == 'R'

            &cRecordSource->( dbRecall() )

         EndIf


         * Unlock **********************************************

         &cRecordSource->(dbrUnlock(&cRecordSource->(recno())))


      Next k


      _HMG_SYSDATA [347] := .T.


   EndIf

   ///////////////////////////////////////////////////////////////////////
   // END RDD DEPENDANT CODE
   ///////////////////////////////////////////////////////////////////////


   ***********************************************************************
   * Cleanup
   ***********************************************************************


   * Restore Original Record Number **************************************

   &cRecordSource->(dbgoto(nRecNo))


   * Set Pending Updates Flag ********************************************

   _HMG_SYSDATA [ 40 ] [ i ] [ 20 ] := .F.


   * Clean Data Buffer ***************************************************

   _HMG_SYSDATA [ 40 ] [ i ] [21] := {}


   * Update New Records Buffer Count *************************************

   _HMG_SYSDATA [ 40 ] [ i ] [ 22 ] := 0


   * Reset Buffered Session Initial Item Count

   _HMG_SYSDATA [ 40 ] [ i ] [ 23 ] := &cRecordSource->(GetDataGridRecCount())


   * Reset Deleted / Recalled Buffer Count

   _HMG_SYSDATA [ 40 ] [ i ] [ 24 ] :=  0


   * Reset Deleted / Recalled Buffer

   _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] := {}


   * Refresh

   DataGridRefresh(i)



   * The End *************************************************************


Return .t.


******************
Function IsBufferedRecordMarkedForDeletion( i , nPhysicalRow )
******
Local lRetVal := .F.
Local k

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
LOCAL cCommand      := ''
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

   For k := 1 To _HMG_SYSDATA [ 40 ] [ i ] [ 24 ]

      cCommand := _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] [ k ] [ 3 ]

      If cCommand == 'D'

         If nPhysicalRow == _HMG_SYSDATA [ 40 ] [ i ] [ 25 ] [ k ] [ 2 ]

            lRetVal := .T.

            Exit

         EndIf

      EndIf

   Next k


Return lRetVal

*****************
Function DataGridRefresh(index , lPreserveSelection )
******
Local cRecordSource
Local nHandle
Local aValue


   * Get Control Data ****************************************************

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]

   nHandle     := _HMG_SYSDATA [ 3 ] [ index ]

   if pcount() == 2

      aValue := _GetValue ( , , index )

   endif

   * Reset Cell Position Data ********************************************

   _HMG_SYSDATA [ 39 ] [index] := 0
   _HMG_SYSDATA [ 15 ] [index] := 0


   * Disable optimization during refresh to avoid wrong repainting *******

   _HMG_SYSDATA [ 40 ] [ index ] [ 27 ] := 0


   * Reset Grid **********************************************************

   ListView_SetItemCount ( nHandle , 0 )

   RedrawWindow( nHandle )


   * Move Record Pointer To Assure a Full Refresh ************************

   &cRecordSource->( dbGoTop() )

   &cRecordSource->( dbGoBottom() )


   * Set New ItemCount ***************************************************

   ListView_SetItemCount ( nHandle , &cRecordSource->( GetDataGridRecCount() ) )

   RedrawWindow( nHandle )


   * Endble optimization *************************************************

   _HMG_SYSDATA [ 40 ] [ index ] [ 27 ] := 255


   * ReSet Selected Row **************************************************

   if pcount() == 2

      _SetValue (  ,  , aValue , index )

   Else

      _SetValue (  ,  , {1,1} , index )

   EndIf

   * The End *************************************************************


Return .t.

*****************
Function DataGridClearBuffer(index)

*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*
local cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]
local nHandle     := _HMG_SYSDATA [ 3 ] [ index ]
*-----------------------------------------------------------------------------*
* Ronaldo M. ronmes@yahoo.com
*-----------------------------------------------------------------------------*

   * Get Control Data ****************************************************

   cRecordSource  := _HMG_SYSDATA [ 40 ] [ index ] [ 10 ]
   nHandle     := _HMG_SYSDATA [ 3 ] [ index ]


   * Set Pending Updates Flag ********************************************

   _HMG_SYSDATA [ 40 ] [ index ] [ 20 ] := .F.


   * Clean Data Buffer ***************************************************

   _HMG_SYSDATA [ 40 ] [ index ] [21] := {}


   * Update New Records Buffer Count *************************************

   _HMG_SYSDATA [ 40 ] [ index ] [ 22 ] := 0


   * Reset Deleted / Recalled Buffer Count *******************************

   _HMG_SYSDATA [ 40 ] [ index ] [ 24 ] :=  0


   * Reset Deleted / Recalled Buffer *************************************

   _HMG_SYSDATA [ 40 ] [ index ] [ 25 ] := {}


   * Refresh *************************************************************

   DataGridRefresh(index)


Return .t.


