/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with
 this software; see the file COPYING. If not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other
 files to produce an executable, this does not by itself cause the resulting
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the
 HMG library code into it.

 Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "hmg.ch"

*------------------------------------------------------------------------------*
Function _DefineMainMenu ( Parent )
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [ 218 ] := 'MAIN'
   _HMG_SYSDATA [ 172 ] := 0
   _HMG_SYSDATA [ 173 ] := 0
   _HMG_SYSDATA [ 174 ] := 0
   _HMG_SYSDATA [ 220 ] := ""

   if valtype(Parent) == 'U'
      Parent := _HMG_SYSDATA [ 223 ]
   Endif

   _HMG_SYSDATA [ 173 ] := GetFormHandle ( Parent )
   _HMG_SYSDATA [ 220 ] := Parent
   _HMG_SYSDATA [ 172 ] := CreateMenu()

Return Nil
*------------------------------------------------------------------------------*
Function _DefineMenuPopup ( Caption , Name )
*------------------------------------------------------------------------------*
Local mVar , k := 0

   If _HMG_SYSDATA [ 218 ] == 'MAIN'

      _HMG_SYSDATA [ 174 ]++

      _HMG_SYSDATA [ 335 ] [ _HMG_SYSDATA [ 174 ] ] := CreatePopupMenu()

      _HMG_SYSDATA [ 336 ] [ _HMG_SYSDATA [ 174 ] ] := Caption

      If _HMG_SYSDATA [ 174 ] > 1
         AppendMenuPopup ( _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] - 1 ] , _HMG_SYSDATA [ 335 ] [ _HMG_SYSDATA [ 174 ] ] , _HMG_SYSDATA [ 336 ] [ _HMG_SYSDATA [ 174 ] ] )
      EndIf

      if valtype (name) != 'U'

         mVar := '_' + _HMG_SYSDATA [ 220 ] + '_' + Name

         k := _GetControlFree()

         Public &mVar. := k

         _HMG_SYSDATA [1] [k] :=  "POPUP"
         _HMG_SYSDATA [2]  [k] :=  Name
         _HMG_SYSDATA [3]  [k] :=  0
         _HMG_SYSDATA [4]  [k] :=  _HMG_SYSDATA [ 173 ]
         _HMG_SYSDATA [  5 ]  [k] :=  0
         _HMG_SYSDATA [  6 ] [k] :=   Nil
         _HMG_SYSDATA [  7 ]  [k] :=   _HMG_SYSDATA [ 172 ]
         _HMG_SYSDATA [  8 ]  [k] :=  Nil
         _HMG_SYSDATA [  9 ]   [k] := ""
         _HMG_SYSDATA [ 10 ]  [k] :=  ""
         _HMG_SYSDATA [ 11 ]  [k] :=  ""
         _HMG_SYSDATA [ 12 ]  [k] :=  ""
         _HMG_SYSDATA [ 13 ]  [k] :=  .F.
         _HMG_SYSDATA [ 14 ]  [k] :=  Nil
         _HMG_SYSDATA [ 15 ]  [k] :=  Nil
         _HMG_SYSDATA [ 16 ]   [k] := ""
         _HMG_SYSDATA [ 17 ]  [k] :=  {}
         _HMG_SYSDATA [ 18 ]  [k] :=  0
         _HMG_SYSDATA [ 19 ]  [k] :=  0
         _HMG_SYSDATA [ 20 ]  [k] :=  0
         _HMG_SYSDATA [ 21 ]  [k] :=  0
         _HMG_SYSDATA [ 22 ]  [k] :=  _HMG_SYSDATA [ 335 ] [ _HMG_SYSDATA [ 174 ] ]
         _HMG_SYSDATA [ 23 ]  [k] :=  -1
         _HMG_SYSDATA [ 24 ]  [k] :=  -1
         _HMG_SYSDATA [ 25 ]  [k] :=  ""
         _HMG_SYSDATA [ 26 ]  [k] :=  0
         _HMG_SYSDATA [ 27 ]  [k] :=  ''
         _HMG_SYSDATA [ 28 ]  [k] :=  0
         _HMG_SYSDATA [ 29 ]  [k] :=  {.f.,.f.,.f.,.f.}
         _HMG_SYSDATA [ 30 ]   [k] :=  ''
         _HMG_SYSDATA [ 31 ]   [k] :=  0
         _HMG_SYSDATA [ 32 ]  [k] :=   0
         _HMG_SYSDATA [ 33 ]  [k] :=   Caption
         _HMG_SYSDATA [ 34 ]  [k] :=   .t.
         _HMG_SYSDATA [ 35 ]  [k] :=   0
         _HMG_SYSDATA [ 36 ]   [k] :=  0
         _HMG_SYSDATA [ 37 ]  [k] :=   0
         _HMG_SYSDATA [ 38 ]  [k] :=   .T.
         _HMG_SYSDATA [ 39 ] [k] := 0
         _HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

      EndIf

   Else

      MsgHMGError("Context/DropDown/Notify Menus Does Not Support SubMenus. Program Terminated")

   EndIf

Return Nil
*------------------------------------------------------------------------------*
Function _EndMenuPopup()
*------------------------------------------------------------------------------*

   If _HMG_SYSDATA [ 218 ] == 'MAIN'

      _HMG_SYSDATA [ 174 ]--

      If _HMG_SYSDATA [ 174 ] == 0
         AppendMenuPopup ( _HMG_SYSDATA [ 172 ] , _HMG_SYSDATA [ 335 ] [ 1 ] , _HMG_SYSDATA [ 336 ] [ 1 ] )
      EndIf

   Else

      MsgHMGError("Context/DropDown/Notify Menus Does Not Support SubMenus. Program Terminated")

   EndIf

Return Nil
*------------------------------------------------------------------------------*
Function _DefineMenuItem ( caption , action , name , Image , checked )
*------------------------------------------------------------------------------*
Local Controlhandle , mVar := '' , k := 0
Local id

   If _HMG_SYSDATA [ 218 ] == 'MAIN'

      Id := _GetId()

      Controlhandle := AppendMenuString ( _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] ] , id ,  caption )

      if Valtype ( image ) != 'U'
         MenuItem_SetBitMaps ( _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] ] , Id , image , '' )
      EndIf

      k := _GetControlFree()

      if valtype (name) != 'U'
         mVar := '_' + _HMG_SYSDATA [ 220 ] + '_' + Name
         Public &mVar. := k
      Else
         *mVar := '_MenuDummyVar'
         *Name := 'DummyMenuName'
         *Public &mVar. := 0
         Name := ''
      EndIf

      _HMG_SYSDATA [1] [k] := "MENU"
      _HMG_SYSDATA [2]  [k] :=  Name
      _HMG_SYSDATA [3]  [k] :=  Controlhandle
      _HMG_SYSDATA [4]  [k] :=  _HMG_SYSDATA [ 173 ]
      _HMG_SYSDATA [  5 ]  [k] :=  id
      _HMG_SYSDATA [  6 ]  [k] :=  action
      _HMG_SYSDATA [  7 ]  [k] :=  _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] ]
      _HMG_SYSDATA [  8 ]  [k] :=  Nil
      _HMG_SYSDATA [  9 ]  [k] :=  ""
      _HMG_SYSDATA [ 10 ]  [k] :=  ""
      _HMG_SYSDATA [ 11 ]  [k] :=  ""
      _HMG_SYSDATA [ 12 ]  [k] :=  ""
      _HMG_SYSDATA [ 13 ]  [k] :=  .F.
      _HMG_SYSDATA [ 14 ]  [k] :=  Nil
      _HMG_SYSDATA [ 15 ] [k] :=   Nil
      _HMG_SYSDATA [ 16 ]   [k] := ""
      _HMG_SYSDATA [ 17 ]  [k] :=  {}
      _HMG_SYSDATA [ 18 ]  [k] :=  0
      _HMG_SYSDATA [ 19 ]   [k] := 0
      _HMG_SYSDATA [ 20 ]  [k] :=  0
      _HMG_SYSDATA [ 21 ]  [k] :=  0
      _HMG_SYSDATA [ 22 ]  [k] :=  0
      _HMG_SYSDATA [ 23 ]  [k] :=  -1
      _HMG_SYSDATA [ 24 ]  [k] :=  -1
      _HMG_SYSDATA [ 25 ]  [k] :=  ""
      _HMG_SYSDATA [ 26 ]  [k] :=  0
      _HMG_SYSDATA [ 27 ]  [k] :=  ''
      _HMG_SYSDATA [ 28 ]  [k] :=  0
      _HMG_SYSDATA [ 29 ]  [k] :=  {.f.,.f.,.f.,.f.}
      _HMG_SYSDATA [ 30 ]   [k] :=  ''
      _HMG_SYSDATA [ 31 ]  [k] :=   0
      _HMG_SYSDATA [ 32 ]   [k] :=  0
      _HMG_SYSDATA [ 33 ]  [k] :=   Caption
      _HMG_SYSDATA [ 34 ]  [k] :=   .t.
      _HMG_SYSDATA [ 35 ]  [k] :=   0
      _HMG_SYSDATA [ 36 ]  [k] :=   0
      _HMG_SYSDATA [ 37 ]   [k] :=  0
      _HMG_SYSDATA [ 38 ]  [k] :=   .T.
      _HMG_SYSDATA [ 39 ] [k] := 0
      _HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

      if checked == .t.
         xCheckMenuItem ( _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] ] , id )
      EndIf

   Else

      id := _GetId()

      Controlhandle := AppendMenuString ( _HMG_SYSDATA [ 175 ] , id ,  caption )

      if Valtype ( image ) != 'U'
         MenuItem_SetBitMaps ( _HMG_SYSDATA [ 175 ] , Id , image , '' )
      EndIf

      k := _GetControlFree()

      if valtype (name) != 'U'
         mVar := '_' + _HMG_SYSDATA [ 221 ] + '_' + Name
         Public &mVar. := k
      Else
         *mVar := '_MenuDummyVar'
         *Name := 'DummyMenuName'
         *Public &mVar. := 0
         Name := ''
      EndIf

      _HMG_SYSDATA [1]  [k] :=   "MENU"
      _HMG_SYSDATA [2]  [k] :=   Name
      _HMG_SYSDATA [3]  [k] :=   Controlhandle
      _HMG_SYSDATA [4]  [k] :=  _HMG_SYSDATA [ 176 ]
      _HMG_SYSDATA [  5 ]  [k] :=   id
      _HMG_SYSDATA [  6 ]  [k] :=   action
      _HMG_SYSDATA [  7 ]  [k] :=   _HMG_SYSDATA [ 175 ]
      _HMG_SYSDATA [  8 ]  [k] :=   Nil
      _HMG_SYSDATA [  9 ]   [k] :=  ""
      _HMG_SYSDATA [ 10 ]  [k] :=   ""
      _HMG_SYSDATA [ 11 ]  [k] :=   ""
      _HMG_SYSDATA [ 12 ]  [k] :=   ""
      _HMG_SYSDATA [ 13 ]  [k] :=   .F.
      _HMG_SYSDATA [ 14 ]  [k] :=   Nil
      _HMG_SYSDATA [ 15 ]  [k] :=   Nil
      _HMG_SYSDATA [ 16 ]  [k] :=   ""
      _HMG_SYSDATA [ 17 ]  [k] :=   {}
      _HMG_SYSDATA [ 18 ]  [k] :=   0
      _HMG_SYSDATA [ 19 ]  [k] :=   0
      _HMG_SYSDATA [ 20 ]  [k] :=   0
      _HMG_SYSDATA [ 21 ]   [k] :=  0
      _HMG_SYSDATA [ 22 ]   [k] :=  0
      _HMG_SYSDATA [ 23 ]  [k] :=   -1
      _HMG_SYSDATA [ 24 ]  [k] :=   -1
      _HMG_SYSDATA [ 25 ]  [k] :=   ""
      _HMG_SYSDATA [ 26 ] [k] :=    0
      _HMG_SYSDATA [ 27 ]  [k] :=   ''
      _HMG_SYSDATA [ 28 ]  [k] :=   0
      _HMG_SYSDATA [ 29 ]  [k] :=   {.f.,.f.,.f.,.f.}
      _HMG_SYSDATA [ 30 ]   [k] :=   ''
      _HMG_SYSDATA [ 31 ]   [k] :=   0
      _HMG_SYSDATA [ 32 ]  [k] :=    0
      _HMG_SYSDATA [ 33 ]  [k] :=    Caption
      _HMG_SYSDATA [ 34 ]  [k] :=    .t.
      _HMG_SYSDATA [ 35 ]   [k] :=   0
      _HMG_SYSDATA [ 36 ]  [k] :=   0
      _HMG_SYSDATA [ 37 ]  [k] :=    0
      _HMG_SYSDATA [ 38 ]  [k] :=    .T.
      _HMG_SYSDATA [ 39 ] [k] := 0
      _HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

      if checked == .t.
         xCheckMenuItem ( _HMG_SYSDATA [ 175 ] , id )
      EndIf

   EndIf

Return Nil
*------------------------------------------------------------------------------*
Function _DefineSeparator ()
*------------------------------------------------------------------------------*

   If _HMG_SYSDATA [ 218 ] == 'MAIN'

      AppendMenuSeparator ( _HMG_SYSDATA [ 335 ] [_HMG_SYSDATA [ 174 ] ] )
   Else

      AppendMenuSeparator ( _HMG_SYSDATA [ 175 ] )

   EndIf

Return Nil
*------------------------------------------------------------------------------*
Function _EndMenu()
*------------------------------------------------------------------------------*
Local i

   Do Case
   Case _HMG_SYSDATA [ 218 ] == 'MAIN'

      SetMenu( _HMG_SYSDATA [ 173 ] , _HMG_SYSDATA [ 172 ] )

   Case _HMG_SYSDATA [ 218 ] == 'CONTEXT'

      i := GetFormIndex ( _HMG_SYSDATA [ 221 ] )
      _HMG_SYSDATA [ 74  ] [i] := _HMG_SYSDATA [ 175 ]

   Case _HMG_SYSDATA [ 218 ] == 'NOTIFY'

      i := GetFormIndex ( _HMG_SYSDATA [ 221 ] )
      _HMG_SYSDATA [ 88 ] [i] := _HMG_SYSDATA [ 175 ]

   Case _HMG_SYSDATA [ 218 ] == 'DROPDOWN'

      _HMG_SYSDATA [ 32 ] [_HMG_SYSDATA [ 169 ]] := _HMG_SYSDATA [ 175 ]

   EndCase

Return Nil
*------------------------------------------------------------------------------*
Function _DisableMenuItem ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local i , h , x

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   xDisableMenuItem ( h , i )

Return Nil
*------------------------------------------------------------------------------*
Function _EnableMenuItem ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local i , h , x

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   xEnableMenuItem ( h , i )

Return Nil
*------------------------------------------------------------------------------*
Function _CheckMenuItem ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local i , h , x

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   xCheckMenuItem ( h , i )

Return Nil
*------------------------------------------------------------------------------*
Function _UncheckMenuItem ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local i , h , x

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   xUncheckMenuItem ( h , i )

Return Nil
*------------------------------------------------------------------------------*
Function _IsMenuItemChecked ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local x,h,i,r,z

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   r := xGetMenuCheckState ( h , i )

   If r == 1
      z := .t.
   Else
      z := .f.
   EndIf

Return z
*------------------------------------------------------------------------------*
Function _IsMenuItemEnabled ( ItemName , FormName )
*------------------------------------------------------------------------------*
Local x,h,i,r,z

   x := GetControlIndex ( ItemName , FormName )

   h := _HMG_SYSDATA [  7 ] [ x ]

   If _HMG_SYSDATA [1] [ x ] == "MENU"
      i := _HMG_SYSDATA [  5 ] [ x ]
   ElseIf _HMG_SYSDATA [1] [ x ] == "POPUP"
      i := _HMG_SYSDATA [ 22 ] [ x ]
   EndIf

   r := xGetMenuEnabledState ( h , i )

   If r == 1
      z := .t.
   Else
      z := .f.
   EndIf

Return z
*------------------------------------------------------------------------------*
Function _DefineContextMenu ( Parent )
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [ 175 ] := 0
   _HMG_SYSDATA [ 176 ] := 0
   _HMG_SYSDATA [ 177 ] := 0
   _HMG_SYSDATA [ 221 ] := ""

   _HMG_SYSDATA [ 218 ] := 'CONTEXT'

   _HMG_SYSDATA [ 174 ] := 0

   if valtype(Parent) == 'U'
      Parent := _HMG_SYSDATA [ 223 ]
   Endif

   _HMG_SYSDATA [ 176 ] := GetFormHandle ( Parent )
   _HMG_SYSDATA [ 221 ] := Parent
   _HMG_SYSDATA [ 175 ] := CreatePopupMenu()

Return Nil

*------------------------------------------------------------------------------*
Function _DefineNotifyMenu ( Parent )
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [ 175 ] := 0
   _HMG_SYSDATA [ 176 ] := 0
   _HMG_SYSDATA [ 177 ] := 0
   _HMG_SYSDATA [ 221 ] := ""

   _HMG_SYSDATA [ 218 ] := 'NOTIFY'

   _HMG_SYSDATA [ 174 ] := 0

   if valtype(Parent) == 'U'
      Parent := _HMG_SYSDATA [ 223 ]
   Endif

   _HMG_SYSDATA [ 176 ] := GetFormHandle ( Parent )
   _HMG_SYSDATA [ 221 ] := Parent
   _HMG_SYSDATA [ 175 ] := CreatePopupMenu()

Return Nil

*------------------------------------------------------------------------------*
Function _DefineDropDownMenu ( Button , Parent )
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [ 175 ] := 0
   _HMG_SYSDATA [ 176 ] := 0
   _HMG_SYSDATA [ 177 ] := 0
   _HMG_SYSDATA [ 221 ] := ""

   _HMG_SYSDATA [ 218 ] := 'DROPDOWN'

   _HMG_SYSDATA [ 174 ] := 0

   if valtype(Parent) == 'U'
      Parent := _HMG_SYSDATA [ 223 ]
   Endif

   _HMG_SYSDATA [ 169 ] := GetControlIndex ( Button , Parent )
   _HMG_SYSDATA [ 176 ] := GetFormHandle ( Parent )
   _HMG_SYSDATA [ 221 ] := Parent
   _HMG_SYSDATA [ 175 ] := CreatePopupMenu()

Return Nil

