/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with
 this software; see the file COPYING. If not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other
 files to produce an executable, this does not by itself cause the resulting
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the
 HMG library code into it.

 Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

MEMVAR _HMG_SYSDATA
#include 'common.ch'

*-----------------------------------------------------------------------------*
Function MsgYesNo ( Message , Title , RevertDefault )
*-----------------------------------------------------------------------------*
Local Retval, t

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   If ValType ( RevertDefault ) == 'L'

      If RevertDefault == .t.
         t := c_msgyesno_id(message,title)
      Else
         t := c_msgyesno(message,title)
      EndIf

   Else

      t := c_msgyesno(message,title)

   EndIf

   if t = 6
      RetVal := .t.
   Else
      RetVal := .f.
   Endif

Return (RetVal)
*-----------------------------------------------------------------------------*
Function MsgRetryCancel ( Message , Title )
*-----------------------------------------------------------------------------*
Local Retval, t

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   t := c_msgretrycancel ( message , title )

   if t = 4
      RetVal := .t.
   Else
      RetVal := .f.
   Endif

Return (RetVal)
*-----------------------------------------------------------------------------*
Function MsgOkCancel ( Message , Title )
*-----------------------------------------------------------------------------*
Local Retval, t

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   t := c_msgokcancel(message,title)

   if t = 1
      RetVal := .t.
   Else
      RetVal := .f.
   Endif

Return (RetVal)

*-----------------------------------------------------------------------------*
Function MsgInfo ( Message , Title )
*-----------------------------------------------------------------------------*

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   c_msginfo(message,title)

Return Nil

*-----------------------------------------------------------------------------*
Function MsgStop ( Message , Title )
*-----------------------------------------------------------------------------*

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   c_msgstop(message,title)

Return Nil

*-----------------------------------------------------------------------------*
Function MsgExclamation ( Message , Title )
*-----------------------------------------------------------------------------*

   DEFAULT Message TO ''
   DEFAULT Title TO ''

   c_msgexclamation(message,title)

Return Nil

*-----------------------------------------------------------------------------*
Function MsgBox ( Message , Title )
*-----------------------------------------------------------------------------*
   DEFAULT Message TO ''
   DEFAULT Title TO ''

   c_msgbox(message,title)

   ProcessMessages()

Return Nil

