/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with
 this software; see the file COPYING. If not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other
 files to produce an executable, this does not by itself cause the resulting
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the
 HMG library code into it.

 Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "hmg.ch"

// #define TV_FIRST      0x1100        //  ok (MinGW)
// #define TVM_EXPAND   (TV_FIRST+2)   //  ok (MinGW)

#define TVM_EXPAND     4354   // ok
#define TVE_COLLAPSE    1     // ok
#define TVE_EXPAND     2      // ok

*------------------------------------------------------------------------------*
Function _DefineTree ( ControlName , ParentForm , row , col , width , height , change , tooltip , fontname , fontsize , gotfocus , lostfocus , dblclick , break , value  , HelpId, aImgNode, aImgItem, noBot , bold, italic, underline, strikeout , itemids , rootbutton )
*------------------------------------------------------------------------------*
Local i , cParentForm , Controlhandle , mVar, ImgDefNode, ImgDefItem, aBitmaps := array(4)
Local FontHandle , k

   _HMG_SYSDATA [ 180 ] := 0
   _HMG_SYSDATA [ 307 ] := 1
   _HMG_SYSDATA [ 337 ] [1] := 0
   _HMG_SYSDATA [ 138 ] := {}
   _HMG_SYSDATA [ 139 ] := {}
   _HMG_SYSDATA [ 259 ] := itemids

   if valtype (rootbutton) == 'L'
      noBot := .Not. RootButton
   endif

   if _HMG_SYSDATA [ 264 ] = .T.
      ParentForm := _HMG_SYSDATA [ 223 ]
      if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
         FontName := _HMG_SYSDATA [ 224 ]
      EndIf
      if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
         FontSize := _HMG_SYSDATA [ 182 ]
      EndIf
   endif
   if _HMG_SYSDATA [ 183 ] > 0
      IF _HMG_SYSDATA [ 240 ] == .F.
      col   := col + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
      row   := row + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]]
      ParentForm := _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
      ENDIF
   EndIf

   If .Not. _IsWindowDefined (ParentForm)
      MsgHMGError("Window: "+ ParentForm + " is not defined. Program terminated" )
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgHMGError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated" )
   endif

   mVar := '_' + ParentForm + '_' + ControlName

   cParentForm := ParentForm

   ParentForm = GetFormHandle (ParentForm)

   if valtype(Value) == "U"
      _HMG_SYSDATA [ 178 ] := 0
   Else
      _HMG_SYSDATA [ 178 ] := Value
   EndIf
   if valtype(Width) == "U"
      Width := 120
   endif
   if valtype(Height) == "U"
      Height := 120
   endif

   if valtype(Row) == "U" .or. valtype(Col) == "U"

      If _HMG_SYSDATA [ 216 ] == 'TOOLBAR'
         Break := .T.
      EndIf

      i := GetFormIndex ( cParentForm )

      if i > 0

         ControlHandle := InitTree ( _HMG_SYSDATA [ 87 ] [i] , col , row , width , height , 0 , '' , 0, iif(noBot,1,0) )
         if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
            FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
         Else
            FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
         endif

         AddSplitBoxItem ( Controlhandle , _HMG_SYSDATA [ 87 ] [i] , Width , break , , , , _HMG_SYSDATA [ 258 ] )

         _HMG_SYSDATA [ 216 ] := 'TREE'

      EndIf

   Else

      ControlHandle := InitTree ( ParentForm , col , row , width , height , 0 , '' , 0, iif(noBot,1,0) )
      if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
         FontHandle := _SetFont (ControlHandle,FontName,FontSize)
      Else
         FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ])
      endif

   endif

   ImgDefNode := iif( valtype( aImgNode ) == "A" , len( aImgNode ), 0 )  //Tree+
   ImgDefItem := iif( valtype( aImgItem ) == "A" , len( aImgItem ), 0 )  //Tree+

   if ImgDefNode > 0

      aBitmaps[1] := aImgNode[1]          // Node default
      aBitmaps[2] := aImgNode[ImgDefNode]

      if ImgDefItem > 0

         aBitmaps[3] := aImgItem[1]       // Item default
         aBitmaps[4] := aImgItem[ImgDefItem]

      else

         aBitmaps[3] := aImgNode[1]        // Copy Node def if no Item def
         aBitmaps[4] := aImgNode[ImgDefNode]

      endif

      InitTreeViewBitmap( ControlHandle, aBitmaps ) //Init Bitmap List
   endif

   _HMG_SYSDATA [ 180 ] := ControlHandle

   If _HMG_SYSDATA [ 265 ] = .T.
      aAdd ( _HMG_SYSDATA [ 142 ] , ControlHandle )
   EndIf

   if valtype(change) == "U"
      change := ""
   endif

   if valtype(gotfocus) == "U"
      gotfocus := ""
   endif

   if valtype(lostfocus) == "U"
      lostfocus := ""
   endif

   if valtype(dblclick) == "U"
      dblclick := ""
   endif

   if valtype(tooltip) != "U"
           SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
   endif

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_SYSDATA [ 179 ] := k

   _HMG_SYSDATA [1] [k] := "TREE"
   _HMG_SYSDATA [2] [k] :=   ControlName
   _HMG_SYSDATA [3] [k] :=   ControlHandle
   _HMG_SYSDATA [4] [k] :=   ParentForm
   _HMG_SYSDATA [  5 ] [k] :=   0
   _HMG_SYSDATA [  6 ] [k] :=   ""
   _HMG_SYSDATA [  7 ]  [k] :=  {}
   _HMG_SYSDATA [  8 ]  [k] :=  Nil
   _HMG_SYSDATA [  9 ]  [k] :=  itemids
   _HMG_SYSDATA [ 10 ] [k] :=   lostfocus
   _HMG_SYSDATA [ 11 ]  [k] :=  gotfocus
   _HMG_SYSDATA [ 12 ]  [k] :=  change
   _HMG_SYSDATA [ 13 ]  [k] :=  .F.
   _HMG_SYSDATA [ 14 ]  [k] :=  Nil
   _HMG_SYSDATA [ 15 ]  [k] :=  Nil
   _HMG_SYSDATA [ 16 ]   [k] := dblclick
   _HMG_SYSDATA [ 17 ]   [k] := {}
   _HMG_SYSDATA [ 18 ]   [k] := Row
   _HMG_SYSDATA [ 19 ]   [k] := Col
   _HMG_SYSDATA [ 20 ]   [k] := Width
   _HMG_SYSDATA [ 21 ]   [k] := Height
   _HMG_SYSDATA [ 22 ]   [k] := 0
   _HMG_SYSDATA [ 23 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 )
   _HMG_SYSDATA [ 24 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 )
   _HMG_SYSDATA [ 25 ]  [k] :=  {}
   _HMG_SYSDATA [ 26 ]  [k] :=  0
   _HMG_SYSDATA [ 27 ]  [k] :=  fontname
   _HMG_SYSDATA [ 28 ]  [k] :=  fontsize
   _HMG_SYSDATA [ 29 ]   [k] := {bold,italic,underline,strikeout}
   _HMG_SYSDATA [ 30 ]   [k] :=  tooltip
   _HMG_SYSDATA [ 31 ]   [k] :=  0
   _HMG_SYSDATA [ 32 ]   [k] :=  0
   _HMG_SYSDATA [ 33 ]   [k] :=  ''
   _HMG_SYSDATA [ 34 ]  [k] :=   .t.
   _HMG_SYSDATA [ 35 ]   [k] :=   HelpId
   _HMG_SYSDATA [ 36 ]   [k] :=  FontHandle
   _HMG_SYSDATA [ 37 ]  [k] :=   0
   _HMG_SYSDATA [ 38 ]  [k] :=   .T.
   _HMG_SYSDATA [ 39 ] [k] := 0
   _HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

Return Nil
*------------------------------------------------------------------------------*
Function _DefineTreeNode ( text, aImage , Id )
*------------------------------------------------------------------------------*
Local    ImgDef, iUnSel, iSel

   If ValType ( Id ) == 'U'
      Id := 0
   EndIf

   ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

   if ImgDef == 0

      iUnsel := 0 // Pointer to defalut Node Bitmaps, no Bitmap loaded
      iSel   := 1

   else
      iUnSel := AddTreeViewBitmap( _HMG_SYSDATA [ 180 ], aImage[1] ) -1
      iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( _HMG_SYSDATA [ 180 ], aImage[2] ) -1 )
      // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
   endif

   _HMG_SYSDATA [ 307 ]++
   _HMG_SYSDATA [ 337 ] [_HMG_SYSDATA [ 307 ]]:= AddTreeItem ( _HMG_SYSDATA [ 180 ] , _HMG_SYSDATA [ 337 ] [_HMG_SYSDATA [ 307 ]-1] , text, iUnsel, iSel , Id )
   aAdd ( _HMG_SYSDATA [ 138 ] , _HMG_SYSDATA [ 337 ] [_HMG_SYSDATA [ 307 ]] )
   aAdd ( _HMG_SYSDATA [ 139 ] , Id )

Return Nil
*------------------------------------------------------------------------------*
Function _EndTreeNode()
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [ 307 ]--

Return Nil
*------------------------------------------------------------------------------*
Function _DefineTreeItem ( text, aImage , Id )
*------------------------------------------------------------------------------*
Local handle, ImgDef, iUnSel, iSel

   If ValType ( Id ) == 'U'
      Id := 0
   EndIf

   ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

   if ImgDef == 0

      iUnsel := 2 // Pointer to defalut Item Bitmaps, no Bitmap loaded
      iSel   := 3

   else
      iUnSel := AddTreeViewBitmap( _HMG_SYSDATA [ 180 ], aImage[1] ) -1
      iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( _HMG_SYSDATA [ 180 ], aImage[2] ) -1 )
      // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
   endif

   handle := AddTreeItem ( _HMG_SYSDATA [ 180 ] , _HMG_SYSDATA [ 337 ] [_HMG_SYSDATA [ 307 ]] , text, iUnSel, iSel , Id )
   aAdd ( _HMG_SYSDATA [ 138 ] , Handle )
   aAdd ( _HMG_SYSDATA [ 139 ] , Id )

Return Nil
*------------------------------------------------------------------------------*
Function _EndTree()
*------------------------------------------------------------------------------*

   _HMG_SYSDATA [  7 ] [ _HMG_SYSDATA [ 179 ] ] := _HMG_SYSDATA [ 138 ]
   _HMG_SYSDATA [ 25 ] [ _HMG_SYSDATA [ 179 ] ] := _HMG_SYSDATA [ 139 ]

   If _HMG_SYSDATA [ 178 ] > 0

      If _HMG_SYSDATA [ 259 ] == .F.
         TreeView_SelectItem ( _HMG_SYSDATA [ 180 ] , _HMG_SYSDATA [ 138 ] [ _HMG_SYSDATA [ 178 ] ] )
      Else
         TreeView_SelectItem ( _HMG_SYSDATA [ 180 ] , _HMG_SYSDATA [ 138 ] [ ascan ( _HMG_SYSDATA [ 139 ] , _HMG_SYSDATA [ 178 ] ) ] )
      EndIf

   EndIf

Return Nil

*------------------------------------------------------------------------------*
Procedure _Collapse ( ControlName , ParentForm , Item )
*------------------------------------------------------------------------------*
Local i , ItemHandle := 0 , Pos

   i := GetControlIndex( ControlName , ParentForm )

   If i > 0

      if _HMG_SYSDATA [  9 ] [i] == .F.
         If Item <= Len ( _HMG_SYSDATA [  7 ] [i] )
            ItemHandle := _HMG_SYSDATA [  7 ] [i] [Item]
         EndIf
      Else
         Pos := ascan ( _HMG_SYSDATA [ 25 ] [i] , Item )
         If Pos > 0
            ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ Pos ]
         EndIf
      EndIf

      If ItemHandle > 0

         SendMessage (  _HMG_SYSDATA [3] [i] , ;
            TVM_EXPAND,;
            TVE_COLLAPSE, ;
            ItemHandle )

      EndIf

   EndIf

Return
*------------------------------------------------------------------------------*
Procedure _Expand ( ControlName , ParentForm , Item )
*------------------------------------------------------------------------------*
Local i , ItemHandle := 0 , Pos

   i := GetControlIndex( ControlName , ParentForm )

   If i > 0

      if _HMG_SYSDATA [  9 ] [i] == .F.
         If Item <= Len ( _HMG_SYSDATA [  7 ] [i] )
            ItemHandle := _HMG_SYSDATA [  7 ] [i] [Item]
         EndIf
      Else
         Pos := ascan ( _HMG_SYSDATA [ 25 ] [i] , Item )
         If Pos > 0
            ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ Pos ]
         EndIf
      EndIf

      If ItemHandle > 0

         SendMessage (  _HMG_SYSDATA [3] [i] , ;
            TVM_EXPAND,;
            TVE_EXPAND, ;
            ItemHandle )

      EndIf

   EndIf

Return
